//
//  AppExtension.swift
//  JobThai
//
//  Created by pinyo on 5/23/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation

extension UITableViewCell {
    
    /**
    For set Edge of UITableViewCell to keep left
    */
    func setEdgeToLeft(){
        // Initialization code
        if self.respondsToSelector(Selector("setSeparatorInset:")) {
            self.separatorInset = UIEdgeInsetsZero
        }
        if self.respondsToSelector(Selector("setLayoutMargins:")) {
            self.layoutMargins = UIEdgeInsetsZero
        }
        if self.respondsToSelector(Selector("setPreservesSuperviewLayoutMargins:")) {
            self.preservesSuperviewLayoutMargins = false
        }
    }
    
    /**
    For hide Seperator Line of UITableViewCell 
    */
    func setCellSeperatorLineHide(tableView : UITableView) {
        self.separatorInset = UIEdgeInsetsMake(0, CGRectGetWidth(tableView.bounds), 0, 0)
    }
}

extension UIViewController {
    func delay(second : Double, closure: ()->()) {
        dispatch_after(
            dispatch_time(DISPATCH_TIME_NOW, Int64(second * Double(NSEC_PER_SEC))),
            dispatch_get_main_queue(),
            closure
        )
    }
}

extension String {
    //MARK: Calculate content size
    func getContentTextFitSize(width widthSize : CGFloat) -> CGSize{
        let contentTextView = UITextView(frame: CGRect(origin: CGPointZero, size: CGSize(width: widthSize, height: CGFloat(MAXFLOAT))))
        contentTextView.text = self
        contentTextView.textContainerInset = UIEdgeInsets(top: 10, left: 16, bottom: 10, right: 5)
        
        let contentSize = contentTextView.sizeThatFits(CGSize(width: UIScreen.mainScreen().bounds.width, height: CGFloat(MAXFLOAT)))
        
        return contentSize
    }
}