//
//  HomeModel.swift
//  JobThai
//
//  Created by weerapon on 1/14/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation

class HomeModel {
    var landingPageList : [LandingPageModel]?
    var corporateList : [CorporateModel]?
    var browseJobsHomeObject : BrowseJobsHomeModel?
    var hotJobsList : [HotJobsModel]?
    var urgenJobstList : [UrgentJobsModel]?
    
    init(jsonObject: NSMutableDictionary) {
        self.landingPageList = convertLandingPage(jsonObject)
        self.corporateList = convertCorporate(jsonObject)
        self.browseJobsHomeObject = convertBrowseJobs(jsonObject)
        self.hotJobsList = convertHotJobs(jsonObject)
        self.urgenJobstList = convertUrgentJobs(jsonObject)
    }
    
    func convertLandingPage(json : NSMutableDictionary)->[LandingPageModel]{
        // Declare Variable Landing
        var landingArray = [LandingPageModel]()
        let landingObject = json.objectForKey("landingPage")
        let landingList = landingObject?.objectForKey("landingPageList")
        
        // Section Landing
        for itemLandingJsonArray in landingList as! NSArray {
            let landingItem = LandingPageModel(item: itemLandingJsonArray as! NSMutableDictionary)
            landingArray.append(landingItem)
        }
        
        return landingArray
    }
    
    func convertCorporate(json : NSMutableDictionary)->[CorporateModel] {
        // Declare Variable Corporate
        var corporateArray = [CorporateModel]()
        let corporateObject = json.objectForKey("corporate")
        let corporateList = corporateObject?.objectForKey("corporateList")
        
        // section Corporate
        for itemCorporateJsonArray in corporateList as! NSArray {
            let corporateItem = CorporateModel(item: itemCorporateJsonArray as! NSMutableDictionary)
            corporateArray.append(corporateItem)
        }
        
        return corporateArray
    }
    
    func convertBrowseJobs(json : NSMutableDictionary)-> BrowseJobsHomeModel {
        return BrowseJobsHomeModel(item : (json.objectForKey("browseJobs") as? NSMutableDictionary)!)
    }
    
    func convertHotJobs(json : NSMutableDictionary)->[HotJobsModel] {
        // Declare Variable HotJobs
        var hotJobsArray = [HotJobsModel]()
        let hotJobsObject = json.objectForKey("hotjobs")
        let hotJobsList = hotJobsObject?.objectForKey("hotJobsList")
        
        // section HotJobs
        for itemHotJobsArray in hotJobsList as! NSArray {
            let HotJobsItem = HotJobsModel(item: itemHotJobsArray as! NSMutableDictionary)
            hotJobsArray.append(HotJobsItem)
        }
        
        return hotJobsArray
    }
    
    func convertUrgentJobs(json : NSMutableDictionary)->[UrgentJobsModel] {
        // Declare Variable UrgentJobs
        var urgentArray = [UrgentJobsModel]()
        let urgentJobsObject = json.objectForKey("urgentJobs")
        let urgentJobsList = urgentJobsObject?.objectForKey("urgentJobsList")
        
        // section UrgentJobs
        for itemUrgentJobsJsonArray in urgentJobsList as! NSArray {
            let urgentJobsItem = UrgentJobsModel(item: itemUrgentJobsJsonArray as! NSMutableDictionary)
            urgentArray.append(urgentJobsItem)
        }
        
        return urgentArray
    }
}