//
//  JTMAllPositionMapViewController.swift
//  JobThai
//
//  Created by pizhayut on 7/7/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMAllPositionMapViewController: JTMBaseViewController, UICollectionViewDataSource, UICollectionViewDelegate, UICollectionViewDelegateFlowLayout {

    let OPEN_JOBDETAIL_PAGE = 0
//    let FROM_SIDE_WIDTH : CGFloat = 16
    let CELL_HEIGHT : CGFloat = 150
    let HEADER_CELL = "JTMAllPositionMapHeaderCollectionViewCell"
    let ALL_POSITION_CELL = "JTMAllPositionMapJobCollectionViewCell"
    let CELL_BETWEEN_PADDING : CGFloat = 0
    
    @IBOutlet weak var countPositionLabel: UILabel!
    @IBOutlet weak var countPositionUnitLabel: UILabel!
    @IBOutlet weak var collectionViewAllPosition: UICollectionView!
    var allPositionMapJobList: NSMutableArray?
    var delegateOnClick : JTMClickAllPositionDelegate?
    var jobdetailPageViewController : JTMJobDetailPageViewController?
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        registerNibFile()
        self.title = applicationDelegate.getLocalizeStringForKey("TITLE_SEARCH_RESULT")
        
        //Add Quick Search Button to SearchResultView
        self.initQuickSearchNavigationItemButton()
        
//        let flowLayout = collectionViewAllPosition.collectionViewLayout as? UICollectionViewFlowLayout
//        flowLayout?.estimatedItemSize = CGSize(width: DEFAULT_FRAME_WIDTH - DEFAULT_CELL_MARGIN, height: 150)
    }

    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        setPositionHeader()
        
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticScreen(SCREEN_RESULT_MAP)
        applicationDelegate.trackGoogleAnalyticEvent(CAT_RESULT_MAP, action: ACTION_VIEW, label: LABEL_VIEW_RESULT_MAP)
    }
    
    // Mark :: Register Nib File
    func registerNibFile() {
        self.collectionViewAllPosition.registerNib(UINib(nibName: ALL_POSITION_CELL, bundle: nil), forCellWithReuseIdentifier: ALL_POSITION_CELL)
        self.collectionViewAllPosition.registerNib(UINib(nibName: HEADER_CELL, bundle: nil), forCellWithReuseIdentifier: HEADER_CELL)
    }
    
    //MARK:- Position Header 
    func setPositionHeader() {
        countPositionLabel.text = applicationDelegate.numFormatter.stringFromNumber((allPositionMapJobList?.count)!)
        countPositionUnitLabel.text = applicationDelegate.getLocalizeStringForKey("PREFIX_POSITION")
    }
    
    //MARK:- CollectionView
    
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1//2
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return /*(section == 0) ? 1 :*/ (allPositionMapJobList?.count)!
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        
//        if indexPath.section == 0 {
//            let item = allPositionMapJobList![indexPath.row]
//            let jobItem = item as? JobItem
//            let cellHeader = collectionView.dequeueReusableCellWithReuseIdentifier(HEADER_CELL, forIndexPath: indexPath) as! JTMAllPositionMapHeaderCollectionViewCell
//            cellHeader.setCellData(jobItem!)
//            
//            if (indexPath.row == self.jobdetailPageViewController?.selectedJob) {
//                cellHeader.selected = true
//            }
//        
//            return cellHeader
//        }
//        else {
            let item = allPositionMapJobList![indexPath.row]
            let jobItem = item as? JobItem
            let cellAllPosition = collectionView.dequeueReusableCellWithReuseIdentifier(ALL_POSITION_CELL, forIndexPath: indexPath) as! JTMAllPositionMapJobCollectionViewCell
            cellAllPosition.setDataCell(jobItem!, sequence: indexPath.row+1)
            if (indexPath.row == self.jobdetailPageViewController?.selectedJob) {
                cellAllPosition.selected = true
            }
            
            return cellAllPosition
//        }
        
    }
    
    // Mark :: Delegate CollectionView Event Click
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticEvent(CAT_RESULT_MAP, action: ACTION_CLICK, label: LABEL_JOB_DETAIL)
        
        let item = allPositionMapJobList![indexPath.row]
        let jobItem = item as? JobItem
        
//        if indexPath.section != 0 {
            JTMJobDetailViewController.openJobDetail(self, companyCode: (jobItem?.companyCode)!, jobcode: (jobItem?.runningNumber)!, type: .JOB_INFO_PAGE)
//        }
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
        let cellWidth = self.view.frame.size.width
        
        
//        let size = CGSize(width: cellWidth , height: CELL_HEIGHT)
//        
//        return size
        
        return collectionView.ar_sizeForCellWithIdentifier(ALL_POSITION_CELL, indexPath: indexPath, fixedWidth: cellWidth, configuration: { (cellItem) in
            let item = self.allPositionMapJobList![indexPath.row]
            let jobItem = item as? JobItem
            
            if let cell = cellItem as? JTMAllPositionMapJobCollectionViewCell {
                cell.setDataCell(jobItem!, sequence: indexPath.row+1)
            }
        })
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumLineSpacingForSectionAtIndex section: Int) -> CGFloat {
        //        return COLLECTIONVIEW_INSET
        //        return CELL_PADDING
        return CELL_BETWEEN_PADDING
    }
    
    
    
    func collectionView(collectionView: UICollectionView, didHighlightItemAtIndexPath indexPath: NSIndexPath) {
        let cell = collectionView.cellForItemAtIndexPath(indexPath) as? JTMAllPositionMapJobCollectionViewCell
        cell?.backgroundColor = JTM_HIGHLIGHT_COLOR
        
    }
    
    func collectionView(collectionView: UICollectionView, didUnhighlightItemAtIndexPath indexPath: NSIndexPath) {
        let cell = collectionView.cellForItemAtIndexPath(indexPath) as? JTMAllPositionMapJobCollectionViewCell
        cell?.backgroundColor = UIColor.whiteColor()
    }
    
//    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, insetForSectionAtIndex section: Int) -> UIEdgeInsets {
//        return UIEdgeInsets(top: DEFAULT_CELL_MARGIN/2, left: DEFAULT_CELL_MARGIN/2, bottom: DEFAULT_CELL_MARGIN/2, right: DEFAULT_CELL_MARGIN/2)
//    }
    
    // Mark :: Set Up Title Navigation
    override func onLanguageChange() {
        super.onLanguageChange()
        self.title = applicationDelegate.getLocalizeStringForKey("TITLE_SEARCH_RESULT")
        setPositionHeader()
    }

}
