//
//  JTMBaseMenuViewController.swift
//  JobThai
//
//  Created by kanya on 1/15/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import ENSwiftSideMenu

class JTMBaseMenuViewController: JTMBaseViewController ,UINavigationControllerDelegate{
    private var tapRecognizer : UITapGestureRecognizer?
    
    let btnHam = UIButton()
    
    override func viewDidLoad() {
        super.viewDidLoad()
        initNavigationItemButton()
        
        self.tapRecognizer = UITapGestureRecognizer(target: self, action: #selector(handleTap(_:)))
        tapRecognizer!.cancelsTouchesInView = false;
        self.view.addGestureRecognizer(tapRecognizer!)
        
        self.navigationController?.delegate = self
        
        onLanguageChange()
    }
    
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        
        print("Menu Appear")
    }
    
    func allowSwipeMenu(allow:Bool){
        self.sideMenuController()?.sideMenu?.allowRightSwipe = allow;
        self.sideMenuController()?.sideMenu?.allowPanGesture = allow;
        self.sideMenuController()?.sideMenu?.allowLeftSwipe = allow;
    }
    override func viewDidAppear(animated: Bool) {
        super.viewDidAppear(animated)
        //allowSwipeMenu(true)
    }
    override func viewDidDisappear(animated: Bool) {
        super.viewDidDisappear(animated)
        //allowSwipeMenu(false)
    }
    func navigationController(navigationController: UINavigationController,willShowViewController viewController: UIViewController,animated: Bool){
        allowSwipeMenu(navigationController.viewControllers.count==1)
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    
    func initNavigationItemButton() {
        
        self.navigationItem.rightBarButtonItem = genUISearchMenuButton()
        if let slideMenuButton: UIBarButtonItem = genUISlidMenuButton() {
            self.navigationItem.leftBarButtonItem = slideMenuButton
        }
    }
    
    
    func genUISearchMenuButton() -> UIBarButtonItem? {
        let btnName = UIButton()
        btnName.setImage(UIImage(named: "ic_search"), forState: .Normal)
        //btnName.setTitle("Menu", forState: .Normal)
        btnName.frame = CGRectMake(0, 0, 25, 25)
        btnName.addTarget(self, action: #selector(JTMBaseMenuViewController.actionSearach), forControlEvents: .TouchUpInside)
        btnName.accessibilityIdentifier = ID_HOME_SEARCH_BUTTON
        
        //.... Set Right/Left Bar Button item
        let rightBarButton = UIBarButtonItem()
        rightBarButton.customView = btnName
        
//        let searchBarButton = UIBarButtonItem(barButtonSystemItem: UIBarButtonSystemItem.Search, target: self, action: #selector(actionSearach))
//        searchBarButton.accessibilityIdentifier = ID_HOME_SEARCH_BUTTON
        
        return rightBarButton //searchBarButton
    }
    
    func genUISlidMenuButton() -> UIBarButtonItem? {
//        let btnName = UIButton()
        btnHam.setImage(UIImage(named: "ic_slide_menu"), forState: .Normal)
        btnHam.setImage(UIImage(named: "ic_slide_menu_active"), forState: .Highlighted)
        btnHam.setImage(UIImage(named: "ic_slide_menu_active"), forState: .Selected)
        
        //btnName.setTitle("Menu", forState: .Normal)
        btnHam.frame = CGRectMake(0, 0, 30, 30)
        btnHam.addTarget(self, action: #selector(actionSlidMenu), forControlEvents: .TouchUpInside)
        btnHam.accessibilityIdentifier = ID_MAIN_NAVIGATION_BAR_MENU_BUTTON
        //.... Set Right/Left Bar Button item
        let leftBarButton = UIBarButtonItem()
        leftBarButton.customView = btnHam
        
        return leftBarButton
    }
    
    func showFirstLevelViewController(){
        let mainStoryboard: UIStoryboard = UIStoryboard(name: "Main",bundle: nil)
        let viewController:UIViewController = mainStoryboard.instantiateViewControllerWithIdentifier("JTMBrowseJobFirstLevelViewController")
        
        self.navigationController?.pushViewController(viewController, animated: true);
    }
    
    func actionSearach() {
        print("Click Search")
        hideSideMenuView()
        openSearchFilter()
        self.view.endEditing(true)
    }
    
    func openSearchFilter() {
        print("openSearchFilter() -- BaseMenu")
        
        let searchFilterStoryboard: UIStoryboard = UIStoryboard(name: "SearchFilter",bundle: nil)
        let viewController:UIViewController = searchFilterStoryboard.instantiateViewControllerWithIdentifier("JTMSearchFilterTypeViewController")
        
        self.navigationController?.pushViewController(viewController, animated: true);
    }
    
    func actionSlidMenu() {
        print("Click Slid Menu")
        //btnHam.selected = !btnHam.selected
        toggleSideMenuView()
        self.view.endEditing(true)
    }
    
    override func onLanguageChange() {
        super.onLanguageChange()
        print("onLanguageChange")
    }
    
    func handleTap(recognizer : UITapGestureRecognizer){
        if(self.sideMenuController() != nil){
            if(isSideMenuOpen() == true){
                hideSideMenuView()
            }
        }
    }
    
    override func showDimBackground() {
        super.showDimBackground()
        btnHam.selected = true
    }
    
    override func hideDimBackground() {
        super.hideDimBackground()
        btnHam.selected = false
    }

}
