//
//  JTMBrowseJobSecondLevelTableViewCell.swift
//  JobThai
//
//  Created by ForAlL on 1/21/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMBrowseJobSecondLevelTableViewCell: UITableViewCell {
    
    @IBOutlet weak var title: JTMLabel!
    @IBOutlet weak var position: JTMLabel!
    @IBOutlet weak var progressBar: UIView!
    @IBOutlet weak var fullProgressBar: UIView!
    @IBOutlet weak var positionUnit: JTMLabel!
    @IBOutlet weak var progressBarWidth: NSLayoutConstraint!
    @IBOutlet weak var progressBarLeading: NSLayoutConstraint!
    @IBOutlet weak var progressBarTrailing: NSLayoutConstraint!
    
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        if self.respondsToSelector(Selector("setSeparatorInset:")) {
            self.separatorInset = UIEdgeInsetsZero
        }
        if self.respondsToSelector(Selector("setLayoutMargins:")) {
            self.layoutMargins = UIEdgeInsetsZero
        }
        if self.respondsToSelector(Selector("setPreservesSuperviewLayoutMargins:")) {
            self.preservesSuperviewLayoutMargins = false
        }
        
    }

//    override func setSelected(selected: Bool, animated: Bool) {
//        super.setSelected(selected, animated: animated)
//
//        fullProgressBar.backgroundColor = JTMLightGray
//        progressBar.backgroundColor = JTMCoreOrange
//        
//        self.selectedBackgroundView = UIView(frame: self.bounds)
//        self.selectedBackgroundView?.backgroundColor = JTMLightGray.colorWithAlphaComponent(0.4)
//        
//    }
   
    func bindModelToCell(secoundLevelModel: SecoundLevelModel) {
        title.text = secoundLevelModel.name
        position.text = applicationDelegate.numFormatter.stringFromNumber(secoundLevelModel.countPosition!)
        positionUnit.text = applicationDelegate.getLocalizeStringForKey("JOB_UNIT")
    }
    
    func setProgressbarWidth(percent:Double) {
        self.layoutIfNeeded()
        
        //let fullWidth = Double(self.frame.width) - Double(progressBarLeading.constant + progressBarTrailing.constant)
        let progressWidth = percent * Double(fullProgressBar.frame.width)
        progressBarWidth.constant = CGFloat(progressWidth)
        
        if(progressBarWidth.constant < 5) {
            progressBarWidth.constant+=5
        }
        
    }
}
