//
//  JTMBrowseJobSecondLevelTableViewController.swift
//  JobThai
//
//  Created by ForAlL on 1/21/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import Alamofire

class JTMBrowseJobSecondLevelViewController: JTMBaseViewController , UITableViewDelegate, UITableViewDataSource{

    
    @IBOutlet weak var browseJobSecondLevelTableView:UITableView!
    
    var numOfData: Int! = 0
    var secoundLevelModel: [SecoundLevelModel]?
    var jobTypeBrowseJob : ModeJobType = .NONE
    var itemFirstLevel : FirstLevelModel?
    var searchCode : String?
    
    // For Track Google Analytic
//    var firstLevelName : String?
    
    override func viewDidLoad() {
        super.viewDidLoad()

        self.browseJobSecondLevelTableView.registerNib(UINib(nibName: "JTMBrowseJobSecondLevelTableViewCell", bundle: nil), forCellReuseIdentifier: "JTMBrowseJobSecondLevelTableViewCell")
        self.browseJobSecondLevelTableView.tableFooterView = UIView(frame: CGRectZero)
        self.browseJobSecondLevelTableView.accessibilityIdentifier = ID_BROWSE_JOBS_SECOND_LEVEL_TABLE_VIEW
        
        self.browseJobSecondLevelTableView.separatorStyle = .None
        
    }

    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        self.browseJobSecondLevelTableView.reloadData()
        
        print("jobTypeBrowseJob :: \(jobTypeBrowseJob)")
        setTrackGoogleAnalyticScreen()
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    
    override func setControllerFlags() {
        isNeedToDimOnConnectionError = true
    }
    
    //MARK:- On Retry Connection
    override func onRetryConnection() {
        super.onRetryConnection()
        if (secoundLevelModel == nil) {
            loadModelBrowseJobSecondLevel(jobTypeBrowseJob, code: searchCode!)
        } else {
            onConnectionSuccess()
        }
    }
    
    //MARK:- Manage View On Connection Error
    override func manageViewOnError(view: UIView) {
        super.manageViewOnError(view)
        if (secoundLevelModel == nil) {
            setAlphaShowToView(view)
        }
    }
    
    //MARK:- Track Google Analytic
    func setTrackGoogleAnalyticScreen() {
        switch (jobTypeBrowseJob) {
        case .CATEGORY :
            applicationDelegate.trackGoogleAnalyticScreen(getScreenBrowseJobLavel2("Category" ,browseJobLevel2: self.title!))
            break
        case .LOCATION :
            applicationDelegate.trackGoogleAnalyticScreen(getScreenBrowseJobLavel2("Province" ,browseJobLevel2: self.title!))
            break
        case .INDUSTRIAL :
            applicationDelegate.trackGoogleAnalyticScreen(getScreenBrowseJobLavel2("Industrial Estate" ,browseJobLevel2: self.title!))
            break
        default :
            break
        }
    }
    
    //MARK:-
    func setModelBrowseJobSecondLevel(secoundLevelModel: [SecoundLevelModel]) {
        self.secoundLevelModel = [SecoundLevelModel]()
        self.secoundLevelModel = secoundLevelModel
        self.numOfData = self.secoundLevelModel?.count
    }
    
    func setModeJobtype(itemFirst : FirstLevelModel ,modeType : ModeJobType) {
        print(modeType)
        self.jobTypeBrowseJob  = modeType
        self.itemFirstLevel = itemFirst
    }
    
    func loadModelBrowseJobSecondLevel(jobType : ModeJobType, code: String){
        self.jobTypeBrowseJob = jobType
        self.searchCode = code
        let serviceController = JTMServiceController()
        let url = getServiceFirstLevel(jobType)
        
        serviceController.requestService(self, urlString: url, params: nil) { (response, status) -> Void in
            if (status == .CONNECTION_SUCCESS) {
                let jsonObject = response!.result.value as? NSMutableDictionary
                let result = jsonObject!.objectForKey("firstLevelList") as! NSArray
                for itemArray in result  {
                    let firstItem = FirstLevelModel(item: (itemArray as? NSMutableDictionary)!)
                    if(firstItem.code == code){
                        self.itemFirstLevel = firstItem
                        self.setModelBrowseJobSecondLevel(firstItem.listSecoundLevelMode!)
                        self.browseJobSecondLevelTableView.reloadData()
                        break;
                    }
                }
            }
        }
    }
    
    func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return numOfData
    }
    
    func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        
        let cell = tableView.dequeueReusableCellWithIdentifier("JTMBrowseJobSecondLevelTableViewCell", forIndexPath: indexPath) as! JTMBrowseJobSecondLevelTableViewCell
        
        cell.bindModelToCell(secoundLevelModel![indexPath.row])
        cell.setProgressbarWidth(self.calculatePercentProgressbarForRow(indexPath.row))
        
        return cell
        
    }
    
    func calculatePercentProgressbarForRow(index:Int) -> Double {
        let allPosition = self.secoundLevelModel![0].countPosition
        let countPosition = self.secoundLevelModel![index].countPosition
        return Double(countPosition!)/Double(allPosition!)
    }
    
    func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        let item : SecoundLevelModel = secoundLevelModel![indexPath.row]
        var param : [String:AnyObject] = [:]
        print(jobTypeBrowseJob)
        
        // Track Google Analytic Event
//        print("first level : \(firstLevelName)")
        print("selected : \(item.name)")
        applicationDelegate.trackGoogleAnalyticEvent(CAT_BROWSE_JOB_LEVEL_2, action: ACTION_CLICK, label: getLabelNameBrowseJobLevel2(self.title!, browseJobLevel2:item.name!))
        
        switch (jobTypeBrowseJob) {
            case .CATEGORY :
                param = [
                    PARAMETER_JOB_TYPE_KEY      : itemFirstLevel!.searchCode!,
                    PARAMETER_SUB_JOB_TYPE_KEY  : item.code!
                ]
                
                    //PARAMETER_JOB_TYPE +  itemFirstLevel!.searchCode! + PARAMETER_SUB_JOB_TYPE + item.code!
                break
            case .LOCATION :
                param = [
                    PARAMETER_JOB_TYPE_KEY      : DEFAULT_PARAMETER,
                    PARAMETER_SUB_JOB_TYPE_KEY  : DEFAULT_PARAMETER,
                    PARAMETER_LOCATION_KEY      : item.code!
                ]
                
                    //PARAMETER_DEFAULT + PARAMETER_LOCATION + item.code!
                break
            case .INDUSTRIAL :
                param = [
                    PARAMETER_JOB_TYPE_KEY      : DEFAULT_PARAMETER,
                    PARAMETER_SUB_JOB_TYPE_KEY  : DEFAULT_PARAMETER,
                    PARAMETER_INDUSTRIAL_KEY    : item.code!
                ]
                
                    //PARAMETER_DEFAULT + PARAMETER_INDUSTRIAL + item.code!
                break
            default :
                break
        }
        JTMBrowseJobViewController.openBrowseJobViewController(self.storyboard!, navigationController: self.navigationController!, type: typeBrowseJob.SEARCH_RESULT, code: item.code, searchParams: param)
        tableView.deselectRowAtIndexPath(indexPath, animated: true)
    }
    
    func tableView(tableView: UITableView, didHighlightRowAtIndexPath indexPath: NSIndexPath) {
        let cell = tableView.cellForRowAtIndexPath(indexPath)
//        cell?.backgroundColor = JTM_LIGHT_GRAY.colorWithAlphaComponent(0.4)
        cell?.backgroundColor = JTM_SELECTED_CELL_BORDER_COLOR.colorWithAlphaComponent(0.4)
    }
    
    func tableView(tableView: UITableView, didUnhighlightRowAtIndexPath indexPath: NSIndexPath) {
        let cell = tableView.cellForRowAtIndexPath(indexPath)
        cell?.backgroundColor = UIColor.clearColor()
    }
    
    func tableView(tableView: UITableView, heightForRowAtIndexPath indexPath: NSIndexPath) -> CGFloat {
        return 60
    }
}

protocol onClickSecondLevelDelegate {
    func onClickItemSecondLevel(index: Int, item : SecoundLevelModel)
}
