//
//  JTMBrowseJobsHeaderView.swift
//  JobThai
//
//  Created by ForAlL on 1/19/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMBrowseJobsHeaderView: UIView {

    var view: UIView!
    var dimView: UIView!
    var headerModel: BrowseJobMainPageModel?
    
    let ALPHA_HIDE : CGFloat = 0
    let ALPHA_SHOW : CGFloat = 1
    
    @IBOutlet weak var countAllPositionLabel: JTMLabel!
    @IBOutlet weak var positionUnitLabel: JTMLabel!
    @IBOutlet weak var topJobSeekWebLabel: JTMLabel!
    @IBOutlet weak var mostVisitLabel: JTMLabel!
    @IBOutlet weak var coveringLabel: JTMLabel!
    @IBOutlet weak var countAllOccupationLabel: JTMLabel!
    @IBOutlet weak var occupationUnitLabel:JTMLabel!
    @IBOutlet weak var fromBusinessLabel:JTMLabel!
    @IBOutlet weak var countAllBusinessLabel:JTMLabel!
    @IBOutlet weak var businessUnitLabel:JTMLabel!
    @IBOutlet weak var updatePrefixLabel:JTMLabel!
    @IBOutlet weak var latestUpdateLabel:JTMLabel!
    
    //Load Nib File
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    func setupUi(){
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
        
        dimView = UIView(frame: bounds)
        dimView.backgroundColor = view.backgroundColor
        addSubview(dimView)
        
        self.reloadData()
    }

    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMBrowseJobsHeaderView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }
    
    func setDataWithModel(browseJobModel:BrowseJobMainPageModel) {
        headerModel = browseJobModel
        
        self.setFixDataToHeader()
        self.setDataToHeader()
    }
    
    func setFixDataToHeader() {
        self.topJobSeekWebLabel.text = applicationDelegate.getLocalizeStringForKey("TOP_JOB_SEEK_WEB")
        self.mostVisitLabel.text    = applicationDelegate.getLocalizeStringForKey("MOST_VISIT")
        self.coveringLabel.text     = applicationDelegate.getLocalizeStringForKey("COVERING")
        self.fromBusinessLabel.text = applicationDelegate.getLocalizeStringForKey("FROM_BUSINESS")
    }
    
    func setDataToHeader() {
        dimView.alpha = ALPHA_HIDE
        self.countAllPositionLabel.text = applicationDelegate.numFormatter.stringFromNumber(headerModel!.countAllPosition!)
        self.positionUnitLabel.text     = applicationDelegate.getLocalizeStringForKey("JOB_UNIT")
        
//        let updatePrefix = applicationDelegate.getLocalizeStringForKey("UPDATE")
        self.updatePrefixLabel.text = applicationDelegate.getLocalizeStringForKey("UPDATE")
        self.latestUpdateLabel.text = (applicationDelegate.appSetting?.currentLanguage == .THAI) ? headerModel!.lastUpdateTh : headerModel!.lastUpdateEn
//        let updateData = (applicationDelegate.appSetting?.currentLanguage == .THAI) ? headerModel!.lastUpdateTh : headerModel!.lastUpdateEn
        
        self.countAllOccupationLabel.text   = applicationDelegate.numFormatter.stringFromNumber(headerModel!.countAllOccupalation!)
        self.occupationUnitLabel.text   = applicationDelegate.getLocalizeStringForKey("OCCUPATION_UNIT")
        
        self.countAllBusinessLabel.text = applicationDelegate.numFormatter.stringFromNumber(headerModel!.countAllBusinessType!)
        self.businessUnitLabel.text     = applicationDelegate.getLocalizeStringForKey("BUSINESS_UNIT")
    }
    
    func setDataForNoService() {
        dimView.alpha = ALPHA_SHOW
//        self.countAllPositionLabel.text = ""
//        self.positionUnitLabel.text     = ""
//        self.countAllOccupationLabel.text   = ""
//        self.occupationUnitLabel.text   = ""
//        self.countAllBusinessLabel.text = ""
//        self.businessUnitLabel.text     = ""
    }
    
    func reloadData() {
        self.setFixDataToHeader()
        
        if (headerModel == nil) {
            setDataForNoService()
        } else {
            setDataToHeader()
        }
    }
}
