//
//  JTMBrowseJobsModeJobsView.swift
//  JobThai
//
//  Created by weerapon on 1/19/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMBrowseJobsModeJobsView : UIView,UICollectionViewDelegate,UICollectionViewDataSource, UICollectionViewDelegateFlowLayout{
    
    @IBOutlet var modeJobsCollection : JTMCollectionView?
    @IBOutlet var textTitle : JTMLabel?
    @IBOutlet weak var modeJobCollectionHeightConstraint: NSLayoutConstraint!
    
    var view: UIView!
    var modeJobsListData : [BrowseJobModeModel]?
    var delegate : JTMBrowseJobsModeJobsViewDelegate?
    var currentIndex : Int? = -1
    
    let spacingMinimumLine   : CGFloat = 10
    let spacingMinimumInterItem : CGFloat = 10
    
    //Load Nib File
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    func setupUi() {
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
        
        textTitle?.text = ""//applicationDelegate.getLocalizeStringForKey("MODE_JOB_TITLE")
        modeJobsCollection?.accessibilityIdentifier = ID_BROWSE_JOBS_MODE_JOBS_COLLECTION_VIEW
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMBrowseJobsModeJobsView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        modeJobsCollection?.delegate = self
        modeJobsCollection?.dataSource = self
        // Initialization code
        modeJobsCollection?.registerNib(UINib(nibName: "JTMModeJobsCollectionViewCell", bundle: nil), forCellWithReuseIdentifier: "JTMModeJobsCollectionViewCell")
    }
 
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        let cell = modeJobsCollection?.cellForItemAtIndexPath(indexPath) as? JTMModeJobsCollectionViewCell
        cell?.setHighlightCell(true)
        
        currentIndex = indexPath.row
        
//        if(currentIndex != indexPath.row){
//            cell?.setHighlightCell(true)
//            
//            //Disable Highlight Old Cell
//            if(currentIndex != -1) {
//                let oldCell = modeJobsCollection?.cellForItemAtIndexPath(NSIndexPath(forRow: currentIndex!, inSection:indexPath.section)) as? JTMModeJobsCollectionViewCell
//                if(cell != nil){
//                    oldCell?.setHighlightCell(false)
//                }
//            }
//            currentIndex = indexPath.row
//        }
        
        delegate?.selectBrowseJobsModeItem(self,item: modeJobsListData![indexPath.row])
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        
        let cell = modeJobsCollection?.dequeueReusableCellWithReuseIdentifier("JTMModeJobsCollectionViewCell", forIndexPath: indexPath) as! JTMModeJobsCollectionViewCell
        cell.setCell(modeJobsListData![indexPath.row])
        
        if(currentIndex == indexPath.row){
            cell.setHighlightCell(true)
        } else {
            cell.setHighlightCell(false)
        }
        return cell
    }
    
    func collectionView(collectionView: UICollectionView, didHighlightItemAtIndexPath indexPath: NSIndexPath) {
        let cell = modeJobsCollection?.cellForItemAtIndexPath(indexPath) as? JTMModeJobsCollectionViewCell
        cell!.setHighlightCell(true)
    }
    
    func collectionView(collectionView: UICollectionView, didUnhighlightItemAtIndexPath indexPath: NSIndexPath) {
//        if(currentIndex != indexPath.row){
            let cell = modeJobsCollection?.cellForItemAtIndexPath(indexPath) as? JTMModeJobsCollectionViewCell
            cell!.setHighlightCell(false)
//        }
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        if( modeJobsListData?.count == nil) {
            return 0
        } else{
            return (modeJobsListData?.count)!
        }
    }

    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1 
    }
    
    func collectionView(collectionView: UICollectionView,layout collectionViewLayout: UICollectionViewLayout,sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
        var widthCell : Double = 0
//        let heightCell : Double = 105
        let widthSpace : Double = Double(spacingMinimumInterItem)
        let numOfCell : Double = 4
        let numOfSpace : Double = 3
        
        widthCell = (Double((modeJobsCollection?.frame.size.width)!) - (widthSpace*numOfSpace))/numOfCell
        return CGSize(width: widthCell, height: Double((modeJobsCollection?.dynamicSize.height)!))
        
//        return (modeJobsCollection?.dynamicSize.height)!
    }
    
    func collectionView(collectionView: UICollectionView,layout collectionViewLayout: UICollectionViewLayout,minimumLineSpacingForSectionAtIndex section: Int) -> CGFloat {
        return spacingMinimumLine
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumInteritemSpacingForSectionAtIndex section: Int) -> CGFloat {
        return spacingMinimumInterItem
    }
    
    func setDataModeJobs(modeJobsList : [BrowseJobModeModel]) {
        textTitle?.text = applicationDelegate.getLocalizeStringForKey("MODE_JOB_TITLE")
        if(modeJobsListData == nil) {
            modeJobsListData = [BrowseJobModeModel]()
        }
        modeJobsListData = modeJobsList
        modeJobsCollection?.reloadData()
        updateUI()
    }
    
    func updateUI() {
        textTitle?.sizeToFit()
        modeJobCollectionHeightConstraint.constant = (modeJobsCollection?.collectionViewLayout.collectionViewContentSize().height)!
    }
    
    func deSelectItem(indexPath: NSIndexPath) {
        let cell = modeJobsCollection?.cellForItemAtIndexPath(indexPath) as? JTMModeJobsCollectionViewCell
        cell?.setHighlightCell(false)
        currentIndex = -1
    }
}

protocol JTMBrowseJobsModeJobsViewDelegate{
    func selectBrowseJobsModeItem(browseJobModeView:JTMBrowseJobsModeJobsView, item : BrowseJobModeModel)
}