//
//  JTMButton.swift
//  JobThai
//
//  Created by tayathorn on 5/31/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMButton : UIButton {
    
    let BUTTON_BG_COLOR : UIColor = UIColor(hexString: "FF5C05")
    let BUTTON_TAP_BG_COLOR : UIColor = UIColor(hexString: "FF772E")
    let BUTTON_TEXT_COLOR : UIColor = UIColor(hexString: "FFFFFF")
    let BUTTON_TAP_TEXT_COLOR : UIColor = UIColor(hexString: "000000")
    
    let FONT_SIZE : CGFloat = 18
    let BUTTON_HEIGHT : CGFloat = 45
    
    @IBOutlet weak var buttonHeightConstraint : NSLayoutConstraint!
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
    }
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        setUpButton()
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        self.setUpButton()
    }
    
    override var highlighted: Bool {
        get {
            return super.highlighted
        }
        set {
            if newValue {  // Highlight
                backgroundColor = BUTTON_TAP_BG_COLOR
            }
            else {  // Normal
                backgroundColor = BUTTON_BG_COLOR
            }
            super.highlighted = newValue
        }
    }
    
    func setUpButton() {
        self.backgroundColor = BUTTON_BG_COLOR
        self.setTitleColor(BUTTON_TEXT_COLOR, forState: .Normal)
        self.layer.cornerRadius = 4
//        self.titleLabel?.font = self.titleLabel?.font.fontWithSize(FONT_SIZE)
        self.buttonHeightConstraint.constant = BUTTON_HEIGHT
    }
        @IBInspectable var iPhone35FontSize:CGFloat = 0 {
            didSet {
                if screenType == DisplaySizeType.SCREEN_3_5_INCH {
                    overrideFontSize(iPhone35FontSize)
                }
            }
        }
    
        @IBInspectable var iPhone4FontSize:CGFloat = 0 {
            didSet {
                if screenType == DisplaySizeType.SCREEN_4_0_INCH {
                    overrideFontSize(iPhone4FontSize)
                }
            }
        }
    
        @IBInspectable var iPhone47FontSize:CGFloat = 0 {
            didSet {
                if screenType == DisplaySizeType.SCREEN_4_7_INCH {
                    overrideFontSize(iPhone47FontSize)
                }
            }
        }
    
        @IBInspectable var iPhone55FontSize:CGFloat = 0 {
            didSet {
                if screenType == DisplaySizeType.SCREEN_5_5_INCH {
                    overrideFontSize(iPhone55FontSize)
                }
            }
        }
    
        @IBInspectable var DefaultFontSize:CGFloat = 0 {
            didSet {
                if screenType == DisplaySizeType.SCREEN_UNKNOWN {
                    overrideFontSize(DefaultFontSize)
                }
            }
        }
    
        func overrideFontSize(fontSize:CGFloat){
            
            self.titleLabel?.font = self.titleLabel?.font.fontWithSize(fontSize)
            
        }
}
