//
//  JTM.swift
//  JobThai
//
//  Created by weerapon on 2/8/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMChangeEmailView: UIView, UITextFieldDelegate {
    
    var view : UIView?
    var delegate : JTMChangeEmailDelegate?
    
    
//    let SMALL_DEVICE_FONT_SIZE : CGFLOAT =
    
//    @IBOutlet weak var newEmailLable : UILabel?
//    @IBOutlet weak var confirmEmailLable : UILabel?
//    @IBOutlet weak var passwordLable : UILabel?
    @IBOutlet weak var saveEmailButton : JTMButton?
    @IBOutlet weak var newEmailTextField : JTMTextField?
    @IBOutlet weak var confirmEmailTextField : JTMTextField?
    @IBOutlet weak var passwordTextField : JTMTextField?
    
    @IBOutlet weak var helperEmailLabel: UILabel!
    
    @IBAction func onSaveEmail() {
        self.endEditing(true)
        delegate?.onSaveEmail()
    }
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUI()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUI()
        setUILable()
    }
    
    func setupUI() {
        view = loadViewFromNib()
        view?.frame = bounds
        view?.autoresizingMask = [.FlexibleWidth, .FlexibleHeight]
        addSubview(view!)
        
        helperEmailLabel.hidden = true
        newEmailTextField?.delegate = self
        confirmEmailTextField?.delegate = self
        passwordTextField?.delegate = self
        
        self.passwordTextField!.font = nil
        self.passwordTextField!.font = self.passwordTextField!.font?.fontWithSize(13)
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMChangeEmailView", bundle: bundle)
        let view =  nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }
    
    func setUILable(){
        
        helperEmailLabel.text = applicationDelegate.getLocalizeStringForKey("HELPER_CHANGE_EMAIL")
        
        newEmailTextField?.placeholder = applicationDelegate.getLocalizeStringForKey("NEW_EMAIL")
        confirmEmailTextField?.placeholder = applicationDelegate.getLocalizeStringForKey("CONFIRM_EMAIL")
        passwordTextField?.placeholder = applicationDelegate.getLocalizeStringForKey("CURRENT_PASSWORD")
        
        saveEmailButton?.setTitle(applicationDelegate.getLocalizeStringForKey("SAVE_EMAIL"), forState: .Normal)
    }
    
    // Dismiss Keyboard
    override func touchesBegan(touches: Set<UITouch>, withEvent event: UIEvent?) {
        view?.endEditing(true)
    }
    
    //Mark:- Textfield delegate
    func textFieldShouldReturn(textField: UITextField) -> Bool {
        let nextTag: NSInteger = textField.tag + 1
        
        if let nextResponder: UIResponder! = textField.superview!.viewWithTag(nextTag){
            nextResponder.becomeFirstResponder()
        }else {
            textField.resignFirstResponder()
            self.onSaveEmail()
        }
        
        return false
    }
    
    func textFieldDidBeginEditing(textField: UITextField) {
        
        if textField == newEmailTextField {
            helperEmailLabel.hidden = false
        }
    }
    
    func textFieldDidEndEditing(textField: UITextField) {
        
        if textField == newEmailTextField {
            self.trimSpace(self.newEmailTextField!)
        } else if textField == confirmEmailTextField {
            self.trimSpace(self.confirmEmailTextField!)
        }
    }
    
    func trimSpace(textField : UITextField) {
        textField.text = textField.text!.stringByTrimmingCharactersInSet(
            NSCharacterSet.whitespaceAndNewlineCharacterSet()
        )
    }
    
    // MARK :- Prevent COPY & PASTE
    override func canPerformAction(action: Selector, withSender sender: AnyObject?) -> Bool {
        return false
    }
    
}

protocol JTMChangeEmailDelegate {
    func onSaveEmail()
}