//
//  JTMFirstLevelCollectionViewCell.swift
//  JobThai
//
//  Created by Isaret Selachun on 20/1/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import MHVideoPhotoGallery

extension Int {
    var asNumberFormat : String{
        let formatter = NSNumberFormatter()
        formatter.numberStyle = .DecimalStyle
        formatter.locale = NSLocale.currentLocale()
        return formatter.stringFromNumber(self)!
        
    }
}

class JTMFirstLevelCollectionViewCell: UICollectionViewCell {
    @IBOutlet weak var titleLabel:JTMLabel?
    @IBOutlet weak var positionLabel:JTMLabel?
    @IBOutlet weak var unitLabel:JTMLabel?
    @IBOutlet weak var imageView:UIImageView?
    
    
    var selectedStateColor =  JTM_CORE_ORANGE
    var normalStateColor = JTM_SELECTED_CELL_BORDER_COLOR
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.layer.borderColor = normalStateColor.CGColor
        self.layer.borderWidth = 1
        self.layer.cornerRadius = 8
        positionLabel?.textColor    = selectedStateColor
    }

    func setCellData(itemJob : AnyObject, isLocation : Bool = false){
        if(isLocation) {
            let item = (itemJob as? SecoundLevelModel)!
            self.titleLabel?.text = item.name
            self.positionLabel?.text = item.countPosition?.asNumberFormat
            self.unitLabel?.text = applicationDelegate.getLocalizeStringForKey("JOB_UNIT")
            self.imageView?.sd_setImageWithURL(NSURL(string: item.imageUrl!)!, placeholderImage: UIImage())
        } else {
            let item = (itemJob as? FirstLevelModel)!
            self.titleLabel?.text = item.name
            self.positionLabel?.text = item.countPosition?.asNumberFormat
            self.unitLabel?.text = applicationDelegate.getLocalizeStringForKey("JOB_UNIT")
            self.imageView?.sd_setImageWithURL(NSURL(string: item.imageUrl!)!, placeholderImage: UIImage())

        }
    }
    
    func setHighlightCell(enable : Bool) {
        if(enable) {
            self.layer.borderColor      = selectedStateColor.CGColor
            titleLabel?.textColor       = selectedStateColor
            unitLabel?.textColor        = selectedStateColor
        } else {
            self.layer.borderColor = normalStateColor.CGColor
            titleLabel?.textColor = UIColor.blackColor()
            unitLabel?.textColor = UIColor.blackColor()
        }
    }
}
