//
//  JTMHotJobsView.swift
//  JobThai
//
//  Created by weerapon on 1/29/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMHotJobsView : UIView, UICollectionViewDataSource, UICollectionViewDelegate , UICollectionViewDelegateFlowLayout {
    
    let HOT_JOBS_CELL_SIZE = CGSize(width: 125, height: 125)
    
    @IBOutlet var hotjobsCollection : JTMCollectionView?
    var delegate : JTMHotJobsViewDelagate?
    var hotJobsListData : [HotJobsModel]?
    var numOfData : Int? = 0
    
    var view: UIView!
    
    //Load Nib File
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    func setupUi(){
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMHotJobsView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }
    
    override func awakeFromNib() {
        super.awakeFromNib()
        hotjobsCollection?.delegate = self
        hotjobsCollection?.dataSource = self
        
        // Initialization code
        hotjobsCollection?.registerNib(UINib(nibName: "JTMHotJobsCollectionViewCell", bundle: nil), forCellWithReuseIdentifier: "JTMHotJobsCollectionViewCell")
    }
    
    func setModelHotJobs(hotJobsList : [HotJobsModel]) {
        self.hotJobsListData = [HotJobsModel]()
        self.hotJobsListData = hotJobsList
        numOfData = self.hotJobsListData?.count
        hotjobsCollection?.reloadData()
    }
    
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        if(hotJobsListData![indexPath.row].companyCode != "-1") {
            delegate?.onHotClick(self, hotJobsItem: self.hotJobsListData![indexPath.row])
        }
    }
    
    //UICollectionview Delegate
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return numOfData!
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier("JTMHotJobsCollectionViewCell", forIndexPath: indexPath) as! JTMHotJobsCollectionViewCell
        cell.setDataToCell(hotJobsListData![indexPath.row])
        return cell
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
//        return HOT_JOBS_CELL_SIZE
        return hotjobsCollection!.dynamicSize
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, minimumInteritemSpacingForSectionAtIndex section: Int) -> CGFloat {
        return 0
    }
}

protocol JTMHotJobsViewDelagate {
    func onHotClick(hotJobsView : JTMHotJobsView, hotJobsItem : HotJobsModel)
    
}
