//
//  JTMJobDetailCompanyHeaderTableViewCell.swift
//  JobThai
//
//  Created by kanya on 4/11/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMJobDetailCompanyHeaderTableViewCell: UITableViewCell, UICollectionViewDataSource, UICollectionViewDelegate, UICollectionViewDelegateFlowLayout {

    let CELL_IDENTIFIER = "JTMJobDetailCompanyImageCollectionViewCell"
    
    @IBOutlet weak var collectionView: UICollectionView!
    var listFeatureImage = [NSURL]()
    var delegate: JTMJobDetailCompanyHeaderCellDelegate?
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        collectionView.dataSource = self
        collectionView.delegate = self
        
        let nib = UINib(nibName: CELL_IDENTIFIER, bundle: nil)
        collectionView.registerNib(nib, forCellWithReuseIdentifier: CELL_IDENTIFIER)
        
        initSelectedBackground()
    }

    override func setSelected(selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)

        // Configure the view for the selected state
    }
    
    func setCellData(jobInfoForCell: CompanyInfoImageModel) {
        
        listFeatureImage.removeAll()
        
        for urlString in jobInfoForCell.valueInfo {
            if let imageUrl = NSURL(string: urlString) {
                print("image = \(urlString): \(imageUrl)")
                listFeatureImage.append(imageUrl)
            }
        }
        
        collectionView.reloadData()
    }
    
    //MARK:- CollectionView
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return listFeatureImage.count
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
        return CGSize(width: 300, height: 144)
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier(CELL_IDENTIFIER, forIndexPath: indexPath) as! JTMJobDetailCompanyImageCollectionViewCell
        cell.image.sd_setImageWithURL(listFeatureImage[indexPath.row], placeholderImage: UIImage())
        return cell
    }
    
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        let cell =  collectionView.cellForItemAtIndexPath(indexPath) as! JTMJobDetailCompanyImageCollectionViewCell
        delegate?.onClickFeatureImage(cell.image, listFeatureImage: listFeatureImage, index: indexPath.row)
    }
    
    //MARK:- Selected background
    func initSelectedBackground() {
        let selectedBackgroundView = UIView(frame: CGRectZero)
        self.selectedBackgroundView = selectedBackgroundView
    }
}


protocol JTMJobDetailCompanyHeaderCellDelegate {
    func onClickFeatureImage(imageView: UIImageView, listFeatureImage: [NSURL], index: Int)
}
