//
//  JTMJobDetailImageTableViewCell.swift
//  JobThai
//
//  Created by kanya on 3/30/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import MHVideoPhotoGallery

class JTMJobDetailImageTableViewCell: UITableViewCell {

    @IBOutlet weak var titleLabel: JTMLabel!
    @IBOutlet weak var jobMapImageView: UIImageView!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        setCellImageBorder()
        initSelectedBackground()
    }

    override func setSelected(selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
    }
    
    //MARK:- Set Cell
    func setCellData(jobInfoForCell: JobInfoModel) {
        setCellTitleLabel(jobInfoForCell.title!)
        setCellImageView(jobInfoForCell.valueInfo!)
    }
    
    func setCellData(jobInfoForCell: CompanyInfoTextModel) {
        setCellTitleLabel(jobInfoForCell.title!)
        setCellImageView(jobInfoForCell.valueInfo!)
    }
    
    func setCellTitleLabel(title: String) {
        self.titleLabel.text = title
    }
    
    func setCellImageView(urlString: String) {
        if let imageUrl = NSURL(string: urlString) {
            self.jobMapImageView.sd_setImageWithURL(imageUrl, placeholderImage: UIImage())
        }
    }
    
    //MARK:- Selected background
    func initSelectedBackground() {
        let selectedBackgroundView = UIView(frame: CGRectZero)
        self.selectedBackgroundView = selectedBackgroundView
    }
    
    func setCellImageBorder() {
        jobMapImageView.layer.borderWidth = 1
        jobMapImageView.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
    }
}
