//
//  JTMJobDetailInfoFooterView.swift
//  JobThai
//
//  Created by kanya on 4/7/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMJobDetailInfoFooterView: UIView {

    @IBOutlet weak var applyButton: JTMButtonWithImageAboveDescriptionView!
    @IBOutlet weak var addFavoriteButton: JTMButtonWithImageAboveDescriptionView!
    @IBOutlet weak var shareButton: JTMButtonWithImageAboveDescriptionView!
    
    //MARK:- Initial
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    //MARK:- Set UI From Nib
    func setupUi(){
        let view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
        
        setDefaultUI()
        
        self.layer.borderWidth = 0.5
        self.layer.borderColor = JTM_FOOTER_BORDER_COLOR.CGColor
        self.backgroundColor = JTM_FOOTER_BG_COLOR //UIColor.clearColor()
        
        // Add Blur Effect
//        let blurEffectView = UIVisualEffectView(effect: UIBlurEffect(style: .Light))
//        blurEffectView.frame = view.bounds
//        blurEffectView.autoresizingMask = [.FlexibleWidth, .FlexibleHeight] // for supporting device rotation
//        self.insertSubview(blurEffectView, atIndex: 0)
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMJobDetailInfoFooterView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }

    //MARK:- Set Button UI
    func setDefaultUI() {
        applyButton.setButtonUIWithData(UIImage(named: "jobTool_Apply_Now")!, title: applicationDelegate.getLocalizeStringForKey("APPLY_NOW"))
        addFavoriteButton.setButtonUIWithData(UIImage(named: "jobTool_Fav")!, title: applicationDelegate.getLocalizeStringForKey("FAVORITE"))
        shareButton.setButtonUIWithData(UIImage(named: "jobTool_Share")!, title: applicationDelegate.getLocalizeStringForKey("SHARE_FRIENDS"))
        
        self.setNeedsLayout()
    }
    
    func setTouchesButtonUI(button: JTMButtonWithImageAboveDescriptionView, isTouch : Bool) {
        
//        var image : String = ""
        
//        if (button === addFavoriteButton) {
//            image = isTouch ? "ic_heart_full" : "ic_heart"
//            button.setButtonUIWithData(UIImage(named: image)!, title: applicationDelegate.getLocalizeStringForKey("FAVORITE"))
//        }
    }
    
    func setAddFavoriteButtonStatus(isFavorite: Bool) {
        let addFavIconName = isFavorite ? "jobTool_Fav_Full" : "jobTool_Fav"
        addFavoriteButton.setButtonUIWithData(UIImage(named: addFavIconName)!, title: applicationDelegate.getLocalizeStringForKey("FAVORITE"))
    }
    
    func setApplyNowButtonStatus(applyButtonDisabledStatus: Bool) {
        applyButton.hidden = applyButtonDisabledStatus
    }

}
