//
//  JTMJobDetailInfoHeaderTableViewCell.swift
//  JobThai
//
//  Created by kanya on 3/30/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMJobDetailInfoHeaderTableViewCell: UITableViewCell {
    
    let JOB_TITLE_VERTICAL_SPACE_TO_DISABLED_WELCOME: CGFloat = 16
    let DISABLED_ICON_IMAGE_HEIGHT_CONSTRAINT: CGFloat = 32
    
    @IBOutlet weak var dateLabel: UILabel!
    @IBOutlet weak var jobTitleLabel: UILabel!
    @IBOutlet weak var disabledIconImageView: UIImageView!
    @IBOutlet weak var disabledWelcomeLabel: UILabel!
    @IBOutlet weak var titleToDisabledVerticalConstraint: NSLayoutConstraint!
    @IBOutlet weak var disabledIconImageHeightConstraint: NSLayoutConstraint!
    
    override func awakeFromNib() {
        super.awakeFromNib()
        initSelectedBackground()
    }

    override func setSelected(selected: Bool, animated: Bool) {
        super.setSelected(selected, animated: animated)
    }
    
    //MARK:- Set Cell
    func setCellData(jobInfoForCell: JobInfoModel, isDisabledPersonWelcome: Bool, textForDisabled: String) {
        self.jobTitleLabel.text = jobInfoForCell.title
        self.dateLabel.text = jobInfoForCell.valueInfo
        self.disabledWelcomeLabel.text = textForDisabled
        
        if isDisabledPersonWelcome {
            self.disabledIconImageView.hidden = false
            self.disabledWelcomeLabel.hidden = false
            self.titleToDisabledVerticalConstraint.constant = JOB_TITLE_VERTICAL_SPACE_TO_DISABLED_WELCOME
            self.disabledIconImageHeightConstraint.constant = DISABLED_ICON_IMAGE_HEIGHT_CONSTRAINT
        } else {
            self.disabledIconImageView.hidden = true
            self.disabledWelcomeLabel.hidden = true
            self.titleToDisabledVerticalConstraint.constant = 0
            self.disabledIconImageHeightConstraint.constant = 0
        }
    }

    //MARK:- Selected background
    func initSelectedBackground() {
        let selectedBackgroundView = UIView(frame: CGRectZero)
        self.selectedBackgroundView = selectedBackgroundView
    }
}
