//
//  JTMMainViewController.swift
//  JobThai
//
//  Created by ForAlL on 1/12/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import ENSwiftSideMenu

class JTMMainViewController: ENSideMenuNavigationController, ENSideMenuDelegate, UIGestureRecognizerDelegate{
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        let sideBarViewController = JTMMainMenuViewController()
        sideBarViewController.parentViewHeight = self.view.frame.size.height - self.navigationBar.frame.size.height - UIApplication.sharedApplication().statusBarFrame.height
        sideBarViewController.parent = self
        sideMenu = ENSideMenu(sourceView: self.view, menuViewController: sideBarViewController, menuPosition:.Left)
        sideMenu?.delegate = self //optional
        sideMenu?.menuWidth = setUpMenuWidth()
//        sideMenu?.menuWidth = JTM_MAIN_MENU_WIDTH // optional, default is 160
        sideMenu?.bouncingEnabled = false
        
        //sideMenu?.allowPanGesture = false
        // make navigation bar showing over side menu
        view.bringSubviewToFront(navigationBar)
        navigationBar.accessibilityIdentifier = ID_MAIN_NAVIGATION_BAR
        
        self.sideMenuAnimationType = .None
        
        sideBarViewController.insertViewControllerWithName(self.viewControllers.first! , forName: JTM_HOME_VIEWCONTROLLER_IDENTIFIER)
        
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
    func setUpMenuWidth() -> CGFloat {
        var menuWidth : CGFloat = 258
        switch screenType {
        case .SCREEN_3_5_INCH:
            menuWidth = 258
        case .SCREEN_4_0_INCH:
            menuWidth = 258
        case .SCREEN_4_7_INCH:
            menuWidth = 258
        case .SCREEN_5_5_INCH:
            menuWidth = 278
        default:
            menuWidth = 258
        }
        
        return menuWidth
    }
    
    // MARK: - ENSideMenu Delegate
    func sideMenuWillOpen() {
//        print("sideMenuWillOpen")
        print("Hey sideMenuWillOpen")
//        NSNotificationCenter.defaultCenter().postNotificationName("showDimBackground", object: self)
    }
    
    func sideMenuWillClose() {
        //        print("sideMenuWillClose")
        print("Hey sideMenuWillClose")
        
//        NSNotificationCenter.defaultCenter().postNotificationName("hideDimBackground", object: self)
    }
    
    func sideMenuDidClose() {
//        print("sideMenuDidClose")
    }
    
    func sideMenuDidOpen() {
//        print("sideMenuDidOpen")
    }

}
