//
//  JTMJobsModeCollectionViewCell.swift
//  JobThai
//
//  Created by weerapon on 1/19/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMModeJobsCollectionViewCell : UICollectionViewCell {
    
    @IBOutlet var jobsModeTitle : JTMLabel?
    @IBOutlet var jobsModeImage : UIImageView?
    
    var border : CAShapeLayer!
    var enable : Bool!
    var selectedStateColor =  JTM_CORE_ORANGE
    var normalStateColor = JTM_SELECTED_CELL_BORDER_COLOR
    
    func setCell(item : BrowseJobModeModel){
        if(applicationDelegate.appSetting?.currentLanguage == appLanguage.THAI){
            self.jobsModeTitle?.text = item.nameTh
        } else {
            self.jobsModeTitle?.text = item.nameEn
        }
        
        self.jobsModeImage?.image = item.image
        //Set Border Layer of Cell
        self.setBorder()
    }
    
    func setBorder() {
        enable = false
        self.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
        self.layer.borderWidth = 1
        self.layer.cornerRadius = 4
    }
    
    func setHighlightCell(enable : Bool) {
        if(enable) {
            self.layer.borderColor = selectedStateColor.CGColor
            self.jobsModeTitle?.textColor = JTM_CORE_ORANGE
        } else {
            self.layer.borderColor = normalStateColor.CGColor
            self.jobsModeTitle?.textColor = UIColor.blackColor()
        }
    }
    
    func setDisHighlightCell() {
        if((self.layer.sublayers?.indexOf(border)) != nil && enable == true){
            self.layer.borderColor = UIColor.blackColor().CGColor
            enable = false
        }
    }
}