
//
//  JTMNoResultView.swift
//  JobThai
//
//  Created by weerapon on 2/19/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMNoResultView: UIView {

    @IBOutlet weak var noResultImage : UIImageView!
    @IBOutlet weak var noResultLabel: JTMLabel!
    @IBOutlet weak var noResultRecommendLabel : JTMLabel!
    var view : UIView!
    
    override init(frame: CGRect) {
        super.init(frame: frame)
        self.setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        self.setupUi()
    }
    
    func setupUi(){
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        self.setNoResultTitle()
        addSubview(view)
        self.hidden = true
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMNoResultView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil)[0] as! UIView
        return view
    }
    
    func setNoResultTitle () {
        let title = applicationDelegate.getLocalizeStringForKey("SEARCH_NO_RESULT_MESSAGE")
        let recommendString = applicationDelegate.getLocalizeStringForKey("SEARCH_NO_RESULT_MESSAGE_RECOMMEND")
        let recommend = convertToAttributeString(recommendString)//NSAttributedString(string: applicationDelegate.getLocalizeStringForKey("SEARCH_NO_RESULT_MESSAGE_RECOMMEND"))
        let imageName = "ic_search_no_result"
        
        setDataForNoResult(title, recommend: recommend, imageName: imageName)
    }
    
    func setNoResultForNoNetwork() {
        let title = applicationDelegate.getLocalizeStringForKey("NO_NETWORK_REACHABLE_MESSAGE")
        let recommend = NSAttributedString(string: "")
        let imageName = "ic_no_internet"
        
        setDataForNoResult(title, recommend: recommend, imageName: imageName)
    }
    
    func setDataForNoResult(title: String, recommend: NSAttributedString, imageName: String) {
        self.noResultLabel.text = title
        self.noResultRecommendLabel.attributedText = recommend
        self.noResultImage.image = UIImage(named: imageName)
    }
    
    func setNoResultTitleWithText(text:String) {
        self.noResultLabel.text = text
    }
    
    func convertToAttributeString(text : NSString)->NSMutableAttributedString{
        let LINE_SPACE_HEIGHT : CGFloat = 10
        let attributeString = NSMutableAttributedString(string: text as String)
        let style = NSMutableParagraphStyle()
        
        style.lineSpacing = LINE_SPACE_HEIGHT
        style.alignment = NSTextAlignment.Center
        attributeString.addAttribute(NSParagraphStyleAttributeName, value: style, range: NSMakeRange(0 , text.length))
        return attributeString
    }
}
