//
//  JTMNoticeTableViewCell.swift
//  JobThai
//
//  Created by pinyo on 2/10/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation
import UIKit

class JTMNoticeTableViewCell : UITableViewCell {
    
    @IBOutlet var titleLabel            : UILabel!
    @IBOutlet var dateLabel             : UILabel!
    @IBOutlet var stackView             : UIStackView!
    @IBOutlet var showButton            : UIImageView!
    @IBOutlet var showArrowButton       : UIButton!
    @IBOutlet weak var newNoticeImage   : UIImageView!
    @IBOutlet weak var noticeView: UIView!
    @IBOutlet var contentTextView       : JTMTextView!
    
    let ICON_PADDING : CGFloat = 5
    
    var newStatus : Bool!
    var contentShowing : Bool! = false
    var contentEdgeInset : UIEdgeInsets = UIEdgeInsetsZero
    
    override func awakeFromNib() {
        super.awakeFromNib()
        // Initialization code
        self.setEdgeToLeft()
    }
    
    func setData( noticeItem : NoticeModel){
        self.titleLabel.text        = noticeItem.title
        self.dateLabel.text         = noticeItem.startDate
        self.contentTextView.text   = noticeItem.content
        showButton.highlighted      = noticeItem.contentShowing
        self.contentEdgeInset = noticeItem.contentEdgeInset
        attachImageLabel(noticeItem.read!)
        setContentViewUI()
    }
    
    func setHideNewLabel( hide : Bool){
        attachImageLabel(hide)
    }
    
    func attachImageLabel(hiddenLabel : Bool) {
        let attachment = NSTextAttachment()
        attachment.image = self.newNoticeImage.image
        attachment.bounds = CGRectMake(0, -5, self.newNoticeImage.bounds.width  , self.newNoticeImage.bounds.height)

        let attributedString = NSAttributedString(attachment: attachment)
        let labelString = NSMutableAttributedString(string: self.titleLabel.text! + " ")
        
        // Set paragraph
        let paragraphStyle = NSMutableParagraphStyle()
        paragraphStyle.lineSpacing = 5
        
        labelString.addAttribute(NSParagraphStyleAttributeName, value:paragraphStyle, range:NSMakeRange(0, labelString.length))
        
        if(!hiddenLabel){
            labelString.appendAttributedString(attributedString)
        }
        
        self.titleLabel.attributedText = labelString
    }
    
    func showContent(show : Bool) {
        showButton.highlighted = show
    }
    
    //MARK: UI
    func setContentViewUI() {
        self.contentTextView?.textContainerInset = contentEdgeInset
    }
}