//
//  JTMSearchButtonCell.swift
//  JobThai
//
//  Created by pinyo on 5/23/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMSearchFooterTableViewCell : UITableViewCell {
    @IBOutlet weak var searchButton: JTMButton?
    @IBOutlet weak var disabilitySwitch : UISwitch?
    @IBOutlet weak var disabilityLabel  : JTMLabel?
    
    let SEARCH_BUTTON_CORNER_RADIUS: CGFloat = 5
    let SEARCH_BUTTON_BORDER_WIDTH: CGFloat = 1
    
    var delegate : JTMSearchFooterTableViewCellDelegate?
    
    override func awakeFromNib() {
        super.awakeFromNib()
        self.initSearchButton()
        self.initDisabilitySwitch()
        self.setEdgeToLeft()
    }
    
    func initSearchButton() {
        searchButton!.layer.cornerRadius = SEARCH_BUTTON_CORNER_RADIUS
        //        searchButton.layer.borderWidth = SEARCH_BUTTON_BORDER_WIDTH
        //        searchButton.layer.borderColor = JTM_CORE_ORANGE.CGColor
        searchButton!.setTitle(applicationDelegate.getLocalizeStringForKey("Search"), forState: UIControlState.Normal)
    }
    
    func initDisabilitySwitch(){
        self.disabilityLabel!.text = applicationDelegate.getLocalizeStringForKey("DISABILITY")
    }
    
    func setDisabilitySwitchState(state : Bool){
        self.disabilitySwitch!.on = state
    }
    
    @IBAction func onClickSearch() {
        delegate!.footerOnClickSearch()
    }
    
    //Disability Switch
    @IBAction func disabilityStateChange( switchState : UISwitch){
        delegate!.footerOnDisabilityStateChange(switchState)
    }
}

protocol JTMSearchFooterTableViewCellDelegate {
    func footerOnClickSearch()
    func footerOnDisabilityStateChange(disabilitySwitch : UISwitch)
}