//
//  JTMSearchResultFilterHeaderView.swift
//  JobThai
//
//  Created by kanya on 5/23/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMSearchResultFilterHeaderView: UICollectionReusableView {

    let VIEW_IDENTIFIER = "JTMSearchResultFilterHeaderView"
    let VIEW_BORDER_WIDTH : CGFloat = 1
    var delegate: JTMSearchResultFilterHeaderDelegate?
    
    @IBOutlet weak var sortFilterTitleLabel: JTMLabel!
    @IBOutlet weak var sortFilterLabel: JTMLabel!
    @IBOutlet weak var backgroundView: UIView!
   
    override func awakeFromNib() {
        super.awakeFromNib()
        setViewBorder()
        addTapGesture()
    }
    
    //MARK:- UI
    func setViewBorder() {
        backgroundView.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
        backgroundView.layer.borderWidth = VIEW_BORDER_WIDTH
    }
    
    //MARK:- Set Data
    func setSortFilter(sortFilterKey: String) {
        sortFilterTitleLabel.text = "\(applicationDelegate.getLocalizeStringForKey("SORT_FILTER_TITLE")) :"
        sortFilterLabel.text = applicationDelegate.getLocalizeStringForKey(sortFilterKey)
    }
    
    //MARK:- Gesture
    func addTapGesture() {
        let tapGesture = UITapGestureRecognizer(target: self, action: #selector(onClickSortFilterHeaderView))
        tapGesture.numberOfTapsRequired = 1
        backgroundView.addGestureRecognizer(tapGesture)
    }
    
    func onClickSortFilterHeaderView() {
        delegate?.onClickCollectionHeader(self)
    }
}

protocol JTMSearchResultFilterHeaderDelegate {
    func onClickCollectionHeader(headerView: JTMSearchResultFilterHeaderView)
}
