//
//  JTMSearchResultGridCollectionViewCell.swift
//  JobThai
//
//  Created by kanya on 2/17/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
//import AlamofireImage
import Alamofire
import MHVideoPhotoGallery

class JTMSearchResultGridCollectionViewCell: UICollectionViewCell {
    
    let GAP_SIZE_SHOW : CGFloat = 8
    let GAP_SIZE_HIDE : CGFloat = 0
    let SALARY_HEIGHT_HIDE : CGFloat = 0
    let SALARY_HEIGHT_SHOW : CGFloat = 20
    
    @IBOutlet weak var topCellSeperatorView: UIView!
    @IBOutlet weak var bottomCellSeperatorView: UIView!
    @IBOutlet weak var topCellSeperatorHeight: NSLayoutConstraint!
    @IBOutlet weak var bottomCellSeperatorHeight: NSLayoutConstraint!
    
    @IBOutlet weak var indexLabel: JTMLabel!
    @IBOutlet weak var dateLabel: JTMLabel!
    
    @IBOutlet weak var positionNameLabel: JTMLabel!
    @IBOutlet weak var companyNameLabel: JTMLabel!
    @IBOutlet weak var descriptionLabel: JTMLabel!
    
    @IBOutlet weak var workLocationLabel: JTMLabel!
    @IBOutlet weak var salaryLabel: JTMLabel!
    @IBOutlet weak var salaryImg: UIImageView!
    @IBOutlet weak var salaryViewHeightConstraint: NSLayoutConstraint!
    
    @IBOutlet weak var companyLogoImageView: UIImageView!
    @IBOutlet weak var companyFeatureImageView: UIImageView!
    
    @IBOutlet weak var descriptionTopConstraint: NSLayoutConstraint!
    @IBOutlet weak var salaryTopConstraint: NSLayoutConstraint!
//    @IBOutlet weak var addFavoriteView: UIView!
//    @IBOutlet weak var addFavoriteIcon: UIImageView!
//    @IBOutlet weak var addFavoriteLabel: UILabel!
    
//    @IBOutlet weak var shareFriendView: UIView!
//    @IBOutlet weak var shareFriendIcon: UIImageView!
//    @IBOutlet weak var shareFriendLabel: UILabel!
    
    var delegate: JTMSearchResultGridCollectionViewCellDelegate?
    var jobData: JobItem?
    var jobIndex: Int?
    
    let SELECTED_BODER_WIDTH: CGFloat = 0
    let BORDER_HEIGHT: CGFloat = JTM_CELL_BORDER_HEIGHT
    let BORDER_COLOR: UIColor = JTM_CELL_SEPERATOR_COLOR
    let SELECTED_BG_COLOR = JTM_HIGHLIGHT_COLOR

    override func awakeFromNib() {
        self.layer.shouldRasterize = true
        self.layer.rasterizationScale = UIScreen.mainScreen().scale
        
        self.setCellBorder()
        self.setSelectedBackgroundView()
        self.setFeatureImage()
//        self.setFavoriteButton()
//        self.setShareButton()
    }
    
    func setCellBorder() {
        self.topCellSeperatorView.backgroundColor = BORDER_COLOR
        self.topCellSeperatorHeight.constant = BORDER_HEIGHT
        
        self.bottomCellSeperatorView.backgroundColor = BORDER_COLOR
        self.bottomCellSeperatorHeight.constant = BORDER_HEIGHT
    }
   
    func setSelectedBackgroundView() {
        let backgroundView = UIView(frame: self.frame)
        backgroundView.backgroundColor = SELECTED_BG_COLOR
        
        self.selectedBackgroundView = backgroundView
    }
    
    //Mark:- Set Data
    func setCellWithData(jobData:JobItem, jobIndex: Int) {
        self.jobData = jobData
        self.jobIndex = jobIndex
        
        self.topCellSeperatorHeight.constant = (jobIndex == 0) ? BORDER_HEIGHT : 0
        self.indexLabel.text        = "\(jobIndex+1)"
        self.dateLabel.text         = jobData.dateText
        self.positionNameLabel.text = jobData.jobTitle
        self.companyNameLabel.text  = jobData.companyName
        self.descriptionLabel.text  = jobData.jobDescription
        self.descriptionTopConstraint.constant = jobData.jobDescription == "" ? GAP_SIZE_HIDE : GAP_SIZE_SHOW
        self.workLocationLabel.text = (jobData.contryCode == "TH") ? jobData.provice : jobData.national
        self.salaryLabel.text       = jobData.salary
        self.salaryImg.hidden       = (jobData.salary == "")
        self.salaryViewHeightConstraint.constant = salaryImg.hidden ? SALARY_HEIGHT_HIDE : SALARY_HEIGHT_SHOW
        self.salaryTopConstraint.constant = salaryImg.hidden ? GAP_SIZE_HIDE : GAP_SIZE_SHOW
        
        if let logoImage = jobData.companyLogo {
            self.companyLogoImageView.sd_setImageWithURL(logoImage, placeholderImage: UIImage())
        }
        
        if let featureImage = jobData.companyFeature {
            self.companyFeatureImageView.sd_setImageWithURL(featureImage, placeholderImage: UIImage())
        }
        
        self.layoutIfNeeded()
       
//        self.setUIAddFavoriteButton(jobData.isResumeFavorite!)
    }
    
    override func preferredLayoutAttributesFittingAttributes(layoutAttributes: UICollectionViewLayoutAttributes) -> UICollectionViewLayoutAttributes {
        return layoutAttributes
    }

    //Mark:- Image
    func setFeatureImage() {
        if (self.companyFeatureImageView != nil) {
            let tapImageGesture = UITapGestureRecognizer(target: self, action: #selector(onClickFeatureImage))
            self.companyFeatureImageView.addGestureRecognizer(tapImageGesture)
        }
    }
    
    func onClickFeatureImage() {
        self.delegate?.onClickFeatureImage(self, index: jobIndex!)
    }
    
//    //Mark:- Add Fav
//    func setUIAddFavoriteButton(isFavorite:Bool) {
//        let imageName = (isFavorite == true) ? "ic_add_fav_orange" : "ic_add_fav_gray"
//        self.addFavoriteIcon.image = UIImage(named: imageName)
//        self.addFavoriteLabel.text = (isFavorite == true) ? "Remove Favorite" : "Add Favorite"
//    }
//    
//    func setFavoriteButton() {
//        let tapFavoriteGesture = UITapGestureRecognizer(target: self, action: "onClickFavoriteButton")
//        self.addFavoriteView.addGestureRecognizer(tapFavoriteGesture)
//    }
//    
//    func onClickFavoriteButton() {
//        if let cellDelegate = self.delegate {
//            cellDelegate.onClickAddFavoriteButton(self, index: jobIndex!, statusLogin: (applicationDelegate.appSetting?.isLogin)!)
//        }
//    }
//    
//    //Mark:- Share
//    func setShareButton() {
//        let tapShareGesture = UITapGestureRecognizer(target: self, action: "onClickShareButton")
//        self.shareFriendView.addGestureRecognizer(tapShareGesture)
//    }
//    
//    func onClickShareButton() {
//        if let cellDelegate = self.delegate {
//            cellDelegate.onClickShareButton(self)
//        }
//    }
}

protocol JTMSearchResultGridCollectionViewCellDelegate {
    func onClickFeatureImage(gridCell:JTMSearchResultGridCollectionViewCell, index:Int)
//    func onClickAddFavoriteButton(gridCell:JTMSearchResultGridCollectionViewCell, index:Int, statusLogin: Bool)
//    func onClickShareButton(gridCell:JTMSearchResultGridCollectionViewCell)
}
