//
//  JTMSearchResultGridViewController.swift
//  JobThai
//
//  Created by weerapon on 2/17/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import Alamofire
import ActionSheetPicker_3_0
import GoogleMobileAds

class JTMSearchResultGirdViewController: JTMBaseViewController, UICollectionViewDataSource, UICollectionViewDelegate, UICollectionViewDelegateFlowLayout, JTMSearchResultGridCollectionViewCellDelegate, JTMSearchResultFilterHeaderDelegate, JTMAppInstallNativeExpressCollectionViewCellDelegate {
    
    @IBOutlet weak var searchResultGridCollectionView: UICollectionView!
    @IBOutlet weak var backToTopButton : UIButton?
    
    var pageIndex : SearchResultPageIndex = .GRID_VIEW
    var indexSelected = -1
//    var isSortFilterChange = false
    
    // parent
    var searchResultController : JTMSearchResultViewController!
    var numberOfItemsPerSection = 0
    
    var delegateMainSeachResult : JTMSeachResultClickSubViewDelegate!
    
    //Cell ResuseIdentifier
    let REUSE_IDENTIFIER_FOR_CELL_WITH_IMAGE_AND_LOGO = "JTMSearchResultGridCollectionViewCellWithImageAndLogo"
    let REUSE_IDENTIFIER_FOR_CELL_WITH_IMAGE = "JTMSearchResultGridCollectionViewCellWithImage"
    let REUSE_IDENTIFIER_FOR_CELL_WITH_LOGO = "JTMSearchResultGridCollectionViewCellWithLogo"
    let REUSE_IDENTIFIER_FOR_CELL = "JTMSearchResultGridCollectionViewCellWithNothing"
    let REUSE_IDENTIFIER_FOR_FOOTER_CELL = "JTMSearchResultListFooterCollectionView"
    let HEADER_VIEW_IDENTIFIER = "JTMSearchResultFilterHeaderView"
    let ADS_IDENTIFIER = "JTMAppInstallNativeExpressCollectionViewCell"
    var ADS_SHOW = true
    
    //Cell Fix Constant
    let HEADER_HEIGHT : CGFloat = 65
    let WIDTH_MARGIN : CGFloat = 15
    let ADS_CELL_OTHER_CONTENT_HEIGHT : CGFloat = 40

    //Back To Top Const.
    let ALPHA_SHOW_BACK_TO_TOP : CGFloat = 0.7
    let ALPHA_HIDE_BACK_TO_TOP : CGFloat = 0
    let INDEX_SHOW_BACK_TO_TOP : Int = 5
    
    //Ads Const.
    let RATIO_FOR_ADS_HEIGHT_CONSTANT : CGFloat = 0.89
    var adsView : GADNativeExpressAdView?
    let APPINSTALL_ADS_UNIT_ID = "ca-app-pub-3273527279427175/6165938562"

    //MARK:- Controller
    override func viewDidLoad() {
        super.viewDidLoad()
        registerNibForCollectionViewCell()
        setUpAdsView()
        
        NSNotificationCenter.defaultCenter().addObserver(self, selector: #selector(updateCloseAdsCell) , name: "SendCloseAds", object: nil)
    }
    
    override func viewDidAppear(animated: Bool) {
        
        updateAdsStatus()
        
        if let searchResultData = searchResultController.searchResultData {
            self.delegateMainSeachResult.setSeachMainPosition(self, position: searchResultData.countAllJob!)
            
            if !(searchResultData.countAllJob > 0) {
                self.delegateMainSeachResult.displayNoResult()
            }
        }
        self.view.layoutIfNeeded()
    }
    
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        initialData()
        
        // Track Google Analytic
        applicationDelegate.trackGoogleAnalyticScreen(SCREEN_SEARCH_RESULT_GRID)
        applicationDelegate.trackGoogleAnalyticEvent(CAT_GRID, action: ACTION_VIEW, label: LABEL_VIEW_RESULT_GRID)
        
//        if isSortFilterChange {
//            onClickBackToTop()
//        }
    }
    
    override func setControllerFlags() {
        isPresentedInOtherController = true
    }
    
    //MARK:- On Retry Connection
    override func onRetryConnection() {
        super.onRetryConnection()
        searchResultController.seachResultMainSeachResult.connectionErrorView?.alpha = VIEW_HIDE_ALPHA
        if !(searchResultController.isLoadFirstService)
            || searchResultGridCollectionView!.visibleCells().contains({$0.isKindOfClass(JTMSearchResultListFooterCollectionView)}){
                callService()
        }
    }
    
    func updateCloseAdsCell() {
        updateAdsStatus()
        searchResultGridCollectionView?.reloadData()
    }
    
    func updateAdsStatus() {
        ADS_SHOW = NSUserDefaults.standardUserDefaults().valueForKey(ADS_USERDEFAULT_KEY) as! Bool
        print("==== ADS IS \(ADS_SHOW) ====")
        
        searchResultController.ADS_COUNT = ADS_SHOW ? 1 : 0
        setNumberOfItem()
    }
    
    //MARK:- Manage View On Error
    override func manageViewOnError(view: UIView) {
        super.manageViewOnError(view)
        if !(searchResultController.isLoadFirstService) {
            if (view == noInternetView) {
                searchResultController.seachResultMainSeachResult.noInternetView?.alpha = VIEW_SHOW_ALPHA
            } else {
                searchResultController.seachResultMainSeachResult.connectionErrorView?.alpha = VIEW_SHOW_ALPHA
            }
        }
    }
    
    func initialData(){
        // set Hiddent Back to top
        self.backToTopButton?.alpha = 0
        searchResultGridCollectionView?.accessibilityIdentifier = ID_SEARCH_RESULT_GRID_COLLECTION_VIEWS
        
        if searchResultController.searchResultData?.jobList.count == nil
            && !(searchResultController.isLoadFirstService) {
            callService()
        } else {
            setNumberOfItem()
            searchResultGridCollectionView?.reloadData()
//            setHighlight()
        }
    }
    
    //Mark:- Collection View
    func registerNibForCollectionViewCell() {
        // Register Cell
        let nibWithImageAndLogo = UINib(nibName: REUSE_IDENTIFIER_FOR_CELL_WITH_IMAGE_AND_LOGO, bundle: nil)
        self.searchResultGridCollectionView.registerNib(nibWithImageAndLogo, forCellWithReuseIdentifier: REUSE_IDENTIFIER_FOR_CELL_WITH_IMAGE_AND_LOGO)
        
        let nibWithImage = UINib(nibName: REUSE_IDENTIFIER_FOR_CELL_WITH_IMAGE, bundle: nil)
        self.searchResultGridCollectionView.registerNib(nibWithImage, forCellWithReuseIdentifier: REUSE_IDENTIFIER_FOR_CELL_WITH_IMAGE)
        
        let nibWithLogo = UINib(nibName: REUSE_IDENTIFIER_FOR_CELL_WITH_LOGO, bundle: nil)
        self.searchResultGridCollectionView.registerNib(nibWithLogo, forCellWithReuseIdentifier: REUSE_IDENTIFIER_FOR_CELL_WITH_LOGO)
        
        let nibWithNothing = UINib(nibName: REUSE_IDENTIFIER_FOR_CELL, bundle: nil)
        self.searchResultGridCollectionView.registerNib(nibWithNothing, forCellWithReuseIdentifier: REUSE_IDENTIFIER_FOR_CELL)
        
        // Register Footer
        let nibFooter = UINib(nibName: REUSE_IDENTIFIER_FOR_FOOTER_CELL, bundle: nil)
        self.searchResultGridCollectionView.registerNib(nibFooter, forCellWithReuseIdentifier: REUSE_IDENTIFIER_FOR_FOOTER_CELL)
        
        // Register Header
        let nibHeader = UINib(nibName: HEADER_VIEW_IDENTIFIER, bundle: nil)
        self.searchResultGridCollectionView.registerNib(nibHeader, forSupplementaryViewOfKind: UICollectionElementKindSectionHeader, withReuseIdentifier: HEADER_VIEW_IDENTIFIER)
        
        let nibAds = UINib(nibName: ADS_IDENTIFIER, bundle: nil)
        self.searchResultGridCollectionView.registerNib(nibAds, forCellWithReuseIdentifier: ADS_IDENTIFIER)
    }
    
    func numberOfSectionsInCollectionView(collectionView: UICollectionView) -> Int {
        return 1
    }
    
    func collectionView(collectionView: UICollectionView, numberOfItemsInSection section: Int) -> Int {
        return self.numberOfItemsPerSection
    }
    
    func collectionView(collectionView: UICollectionView, cellForItemAtIndexPath indexPath: NSIndexPath) -> UICollectionViewCell {
        if !isAdsCell(indexPath.row) && !isLoadMoreCell(indexPath.row) { //Job Grid Cell
            let cell = setDataForJobGridCellAtIndex(collectionView, indexPath: indexPath)
            
            return cell
        } else if isAdsCell(indexPath.row) {
            let cell = collectionView.dequeueReusableCellWithReuseIdentifier(ADS_IDENTIFIER, forIndexPath: indexPath) as? JTMAppInstallNativeExpressCollectionViewCell
            cell?.delegate = self
            cell?.updateBorderForCell(indexPath.row)
            adsView?.frame = CGRect(origin: CGPoint(x: WIDTH_MARGIN/2, y: ADS_CELL_OTHER_CONTENT_HEIGHT - 10), size: (adsView?.frame.size)!)
            cell?.addSubview(adsView!)
            
            return cell!
        } else { //Load More
            let cell = collectionView.dequeueReusableCellWithReuseIdentifier(REUSE_IDENTIFIER_FOR_FOOTER_CELL, forIndexPath: indexPath) as? JTMSearchResultListFooterCollectionView
            cell?.accessibilityIdentifier = ID_LOAD_MORE
            
            return cell!
        }
    }
    
    func setDataForJobGridCellAtIndex(collectionView: UICollectionView, indexPath: NSIndexPath) -> UICollectionViewCell {
        let itemIndex = getJobItemIndexFormIndexPath(indexPath)
        let itemData = (self.searchResultController.searchResultData?.jobList[itemIndex])!
        let reuseIdentifier = self.getReuseIdentifierForData(itemData)
        let cell = collectionView.dequeueReusableCellWithReuseIdentifier(reuseIdentifier, forIndexPath: indexPath) as? JTMSearchResultGridCollectionViewCell
        cell?.delegate = self
        cell?.setCellWithData(itemData, jobIndex: itemIndex)
        return cell!
    }
    
    func closeAds() {

        // create the alert
        let alert = UIAlertController(title: applicationDelegate.getLocalizeStringForKey("DESCRIPTION_ALERT_ADS"), message: "", preferredStyle: UIAlertControllerStyle.Alert)
        
        // add an action (button)
        alert.addAction(UIAlertAction(title: applicationDelegate.getLocalizeStringForKey("ALERT_OK"), style: UIAlertActionStyle.Default, handler: {(UIAlertAction) -> Void in
            NSUserDefaults.standardUserDefaults().setValue(false, forKey: ADS_USERDEFAULT_KEY)
            self.updateAdsStatus()
            self.searchResultGridCollectionView?.reloadData()
            print("==== SUCCESSFULLY REMOVE ADS ====")
            NSNotificationCenter.defaultCenter().postNotificationName("SendCloseAds", object: nil)
            applicationDelegate.trackGoogleAnalyticEvent(CAT_GRID, action: ACTION_CLICK, label: LABEL_CLOSE_ADS)
        }))
        alert.addAction(UIAlertAction(title: applicationDelegate.getLocalizeStringForKey("ALERT_CANCEL"), style: UIAlertActionStyle.Cancel, handler: nil))
        // show the alert
        self.presentViewController(alert, animated: true, completion: nil)
        
        ////        NSUserDefaults.standardUserDefaults().valueForKey("Ads")
    
    }
    
    //Mark:- Collection Cell Size
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, sizeForItemAtIndexPath indexPath: NSIndexPath) -> CGSize {
        if !isAdsCell(indexPath.row) && !isLoadMoreCell(indexPath.row) { //Job Grid Cell
           return  self.calculateCollectionViewCellHeightForDataAtIndex(collectionView, indexPath: indexPath)
        } else if isAdsCell(indexPath.row) {
            let cellHeight : CGFloat = ((DEFAULT_FRAME_WIDTH - WIDTH_MARGIN) * RATIO_FOR_ADS_HEIGHT_CONSTANT) + ADS_CELL_OTHER_CONTENT_HEIGHT + JTM_CELL_BORDER_HEIGHT
            return  CGSizeMake(getCellWidth(collectionView), cellHeight)
        } else { //Load More
           return  CGSizeMake(getCellWidth(collectionView), LOADMORE_CELL_HEIGHT)
        }
    }
    
    func calculateCollectionViewCellHeightForDataAtIndex(collectionView:UICollectionView, indexPath:NSIndexPath) -> CGSize {
        let itemIndex = getJobItemIndexFormIndexPath(indexPath)
        let itemData = self.searchResultController.searchResultData?.jobList[itemIndex]
        let cellWidth = getCellWidth(collectionView)
        
        return collectionView.ar_sizeForCellWithIdentifier(getReuseIdentifierForData(itemData!), indexPath: indexPath, fixedWidth: cellWidth, configuration: { (cellItem) in
            if let cell = cellItem as? JTMSearchResultGridCollectionViewCell {
//                cell.delegate = self
                cell.setCellWithData(itemData!, jobIndex: itemIndex)
            }
        })
    }
    
    func getCellWidth(collectionView: UICollectionView) -> CGFloat {
        return collectionView.frame.width - DEFAULT_SEARCH_RESULT_CELL_MARGIN
    }
    
    //MARK:- Collection Delegate
    func collectionView(collectionView: UICollectionView, didSelectItemAtIndexPath indexPath: NSIndexPath) {
        let itemIndex = getJobItemIndexFormIndexPath(indexPath)
        
        if  !isAdsCell(indexPath.row) && !isLoadMoreCell(indexPath.row) {
            // Track Google Analytic Event
            applicationDelegate.trackGoogleAnalyticEvent(CAT_GRID, action: ACTION_CLICK, label: LABEL_JOB_DETAIL)
            self.delegateMainSeachResult?.onClickSubView(self, item: (self.searchResultController.searchResultData?.jobList[itemIndex])!)
            indexSelected = indexPath.row
        }
    }
    
    //MARK:- Collection Header
    func collectionView(collectionView: UICollectionView, viewForSupplementaryElementOfKind kind: String, atIndexPath indexPath: NSIndexPath) -> UICollectionReusableView {
        
        if (kind == UICollectionElementKindSectionHeader) {
            let headerView = collectionView.dequeueReusableSupplementaryViewOfKind(UICollectionElementKindSectionHeader,
                withReuseIdentifier: HEADER_VIEW_IDENTIFIER,
                forIndexPath: indexPath) as! JTMSearchResultFilterHeaderView
            headerView.delegate = self
            headerView.accessibilityIdentifier = ID_SORT_FILTER_HEADER_CELL
            headerView.setSortFilter(self.searchResultController.searchResultSortFilterList[self.searchResultController.sortFilterIndex].localizeKey!)
            return headerView
        }
        
        return UICollectionReusableView()
    }
    
    func collectionView(collectionView: UICollectionView, layout collectionViewLayout: UICollectionViewLayout, referenceSizeForHeaderInSection section: Int) -> CGSize {
        if (numberOfItemsPerSection > 0) {
            return CGSize(width: collectionView.frame.width, height: HEADER_HEIGHT)
        } else {
            return CGSizeZero
        }
    }

    //Mark:- Call Service
    func callService() {
        let serviceController = JTMServiceController()
        let url = getServiceSearchResult()
        
        var params = self.searchResultController.getParamForSearch()
        params["page"] = self.searchResultController.nextPage
        self.delegateMainSeachResult.setButtonEnableStatus(false)
        searchResultController.enableSwipePageView(false)
        searchResultController.isLoadingService = true
        serviceController.requestService(self, urlString: url, params: params, isPresentLoadingIndicator: !searchResultController.isLoadFirstService) { (response, status) -> Void in
            if (status == .CONNECTION_SUCCESS) {
                self.searchResultController.nextPage += 1
                let jsonObject = response!.result.value as? NSMutableDictionary
                if (!self.searchResultController.isLoadFirstService) {
                    self.parseJsonToModel(jsonObject!)
                    self.searchResultController.isLoadFirstService = true
                    self.delegateMainSeachResult!.setSeachMainPosition(self, position: (self.searchResultController.searchResultData?.countAllJob)!)
                } else {
                    self.addJobList(jsonObject!)
                }
                self.searchResultGridCollectionView?.reloadData()
            } else if (status == .CONNECTION_UNREACHABLE) {
                if !self.searchResultController.isFirstNotConnectInternet {
                    self.searchResultController.seachResultMainSeachResult.showAlertNoNetworkIsReachable()
                    self.searchResultController.isFirstNotConnectInternet = true
                }
            }
            self.delegateMainSeachResult.setButtonEnableStatus(true)
            self.searchResultController.enableSwipePageView(true)
            self.searchResultController.isLoadingService = false
        }
    }
    
    //MARK:- About Data
    func parseJsonToModel(jsonResult : NSMutableDictionary) {
        self.searchResultController.searchResultData = SearchResultModel(result: jsonResult)
        self.searchResultController.allCountPage = (self.searchResultController.searchResultData?.countPage)!
        //searchResultController.ADS_SHOW = (searchResultController.searchResultData?.showAds)!
        searchResultController.updateAdsPosition()
        setNumberOfItem()
 
        if (self.searchResultController.searchResultData?.countAllJob == 0) {
            self.delegateMainSeachResult.displayNoResult()
        }
        
        self.delegateMainSeachResult.updateMapButtonEnable((self.searchResultController.searchResultData?.isHasResultMap)!)
        self.searchResultController.updatePageTitleList()
    }
    
    func addJobList(jsonResult : NSMutableDictionary) {
        let searchJobObject = SearchResultModel(result: jsonResult)
        self.searchResultController.searchResultData!.jobList = self.searchResultController.searchResultData!.jobList + searchJobObject.jobList
        setNumberOfItem()
    }
    
    func getReuseIdentifierForData(itemData:JobItem) -> String {
        if (itemData.companyLogo != nil && itemData.companyFeature != nil) {
            return REUSE_IDENTIFIER_FOR_CELL_WITH_IMAGE_AND_LOGO
        } else if (itemData.companyLogo != nil) {
            return REUSE_IDENTIFIER_FOR_CELL_WITH_LOGO
        } else if (itemData.companyFeature != nil) {
            return REUSE_IDENTIFIER_FOR_CELL_WITH_IMAGE
        } else {
            return REUSE_IDENTIFIER_FOR_CELL
        }
    }
    
    func setNumberOfItem() {
        //Check 0 record of data
        if self.searchResultController.searchResultData == nil {
            self.numberOfItemsPerSection = 0
            return
        }
        
        self.numberOfItemsPerSection = (self.searchResultController.searchResultData?.jobList.count)!
        
        //Check to add loadmore cell
        if self.searchResultController.nextPage <= self.searchResultController.allCountPage {
            self.numberOfItemsPerSection += 1
        }
        
        //Check to add ads cell
        if self.numberOfItemsPerSection > searchResultController.ADS_POSITION_GRID {
            self.numberOfItemsPerSection += searchResultController.ADS_COUNT
        }
    }
    
    func getJobItemIndexFormIndexPath(indexPath: NSIndexPath) -> Int {
        let itemIndex = isIndexAfterAdsCell(indexPath.row) ? indexPath.row - 1 : indexPath.row
        
        return itemIndex
    }
    
    func getIndexPathFromJobItemIndex(index: Int) -> NSIndexPath {
        let indexRow = isAdsCell(index) || isIndexAfterAdsCell(index) ? index + 1 : index
        
        return NSIndexPath(forRow: indexRow, inSection: 0)
    }
    
    func isLoadMoreCell(index: Int) -> Bool {
        return index + 1 > (self.searchResultController.searchResultData?.jobList.count)! + searchResultController.ADS_COUNT
    }
    
    func isAdsCell(index: Int) -> Bool {
        return (index == searchResultController.ADS_POSITION_GRID) && ADS_SHOW
    }
    
    func isIndexAfterAdsCell(index: Int) -> Bool {
        return (index > searchResultController.ADS_POSITION_GRID) && ADS_SHOW && !isLoadMoreCell(index)
    }
    
    func loadMoreService(){
        if !isLoadingService && !(searchResultController.isLoadingService) && self.searchResultController.nextPage <= self.searchResultController.allCountPage {
            callService()
        }
    }
    
    //MARK:- ADS
    func setUpAdsView() {
        
        if adsView == nil {
            let cellHeight : CGFloat = ((DEFAULT_FRAME_WIDTH - WIDTH_MARGIN) * RATIO_FOR_ADS_HEIGHT_CONSTANT)
            let frame = CGSizeMake(DEFAULT_FRAME_WIDTH - 15, cellHeight)
            adsView = GADNativeExpressAdView.init(frame: CGRect(origin: CGPointZero, size: frame))
            adsView?.rootViewController = self
            adsView?.adUnitID = APPINSTALL_ADS_UNIT_ID
        }
        
        let request = GADRequest()
        // ADS SETTING GRID
        if ADS_SIMULATION {
            request.testDevices = [ kGADSimulatorID ];
        }
        adsView?.loadRequest(request)
    }
    
    //MARK:- Header View Delegate
    func onClickCollectionHeader(headerView: JTMSearchResultFilterHeaderView) {
        if (applicationDelegate.appSetting?.isNetworkReachable)! {
            showSortFilterPickerView()
        }
    }

    //MARK:- Sort Filter Picker View
    func showSortFilterPickerView() {
        var sortFilterList = [String]()
        for sortFilterItem in self.searchResultController.searchResultSortFilterList {
            sortFilterList.append(applicationDelegate.getLocalizeStringForKey(sortFilterItem.localizeKey!))
        }
        
        let currentFilter = self.searchResultController.sortFilterIndex
        
        let actionPicker = ActionSheetStringPicker(title: "",
                                                   rows: sortFilterList,
                                                   initialSelection: currentFilter,
                                                   doneBlock: { (picker, row, value) -> Void in
                                                    self.updateSearchResultByFilterAtIndex(row)
            }, cancelBlock: { (picker) -> Void in
                
            }, origin: self.view)
        
        actionPicker.setCancelButton(UIBarButtonItem(title: applicationDelegate.getLocalizeStringForKey("Cancel"), style: UIBarButtonItemStyle.Plain, target: self, action: nil))
        actionPicker.setDoneButton(UIBarButtonItem(title: applicationDelegate.getLocalizeStringForKey("Done"), style: UIBarButtonItemStyle.Done, target: self, action: nil))
        actionPicker.tapDismissAction = TapAction.Cancel
        
        actionPicker.showActionSheetPicker()
    }
    
    func updateSearchResultByFilterAtIndex(index: Int) {
        let selectedFilter = self.searchResultController.searchResultSortFilterList[index].localizeKey!
        
        // Track Google Analytic Event
        applicationDelegate.trackGoogleAnalyticEvent(CAT_GRID, action: ACTION_CLICK, label: getLabelNameSort(applicationDelegate.getLocalizeStringForKey(selectedFilter)))
        if (self.searchResultController.sortFilterIndex != index) {
            self.searchResultController.setSortFilter(index)
//            self.setNumberOfItem()
//            self.searchResultGridCollectionView?.reloadData()
//            isSortFilterChange = false
            self.callService()
        }
    }
    
    //MARK:- Action
    @IBAction func onClickBackToTop() {
        self.searchResultGridCollectionView?.setContentOffset(CGPoint(x: 0, y: 0), animated: true)
    }
    
    //MARK:- Cell Delegate
    func onClickFeatureImage(gridCell: JTMSearchResultGridCollectionViewCell, index: Int) {
        // Track Google Analytic Event
        applicationDelegate.trackGoogleAnalyticEvent(CAT_GRID, action: ACTION_CLICK, label: LABEL_IMAGE_COMPANY)
        
        let jobData = self.searchResultController.searchResultData?.jobList[index]
        
        self.openImageGallery(gridCell.companyFeatureImageView, listImageUrl: [(jobData?.companyFeature)!])
    }
    
    func setHighlight() {
        self.searchResultGridCollectionView?.selectItemAtIndexPath(NSIndexPath(forItem: indexSelected, inSection: 0),
                                                                   animated: false,
                                                                   scrollPosition: .None)
    }
    
    // Mark: Scroll View
    func scrollViewDidScroll(scrollView: UIScrollView) {
        let offset : CGPoint = scrollView.contentOffset;
        let bounds : CGRect = scrollView.bounds;
        let size : CGSize = scrollView.contentSize;
        let inset : UIEdgeInsets = scrollView.contentInset;
        let y : CGFloat = offset.y + bounds.size.height - inset.bottom;
        let h  : CGFloat = size.height;
        
        if(y > h - RELOAD_DISTANCE){
            loadMoreService()
        }
        
        let visibleIndex = searchResultGridCollectionView.indexPathsForVisibleItems()
        
        if visibleIndex.count > 0 {
            let arrayVisible = visibleIndex.sort {$0.row < $1.row}
            let index = arrayVisible[0].row + 1
            
            if(index >= self.INDEX_SHOW_BACK_TO_TOP && scrollView.contentOffset.y != 0) {
                self.backToTopButton?.alpha = self.ALPHA_SHOW_BACK_TO_TOP
            } else {
                self.backToTopButton?.alpha = self.ALPHA_HIDE_BACK_TO_TOP
            }
        }
    }
    
    //Mark:- Cell Dalegate
    //    func onClickShareButton(gridCell: JTMSearchResultGridCollectionViewCell) {
    //        self.showAlertWithData("Share Friend", message: nil, completionHandler: nil, actionList: nil)
    //    }
    //
    //    func onClickAddFavoriteButton(gridCell: JTMSearchResultGridCollectionViewCell, index: Int, statusLogin: Bool) {
    //        if statusLogin {
    //            let jobData = self.searchResultController.searchResultData?.jobList[index]
    //            let isAddFavorite:Bool = !(jobData!.isResumeFavorite!)
    //
    //            if (isAddFavorite == true) {
    //                applicationDelegate.appSetting?.callServiceAddFavoriteForJobCode(self,
    //                                                            jobCode: (jobData?.runningNumber)!,
    //                                                            completion: { () -> Void in
    //                                                                gridCell.setUIAddFavoriteButton(isAddFavorite)
    //                                                                jobData?.isResumeFavorite = isAddFavorite
    //                                                            })
    //            } else {
    //                let cancelAction = UIAlertAction(title: applicationDelegate.getLocalizeStringForKey("CANCEL"),
    //                                                                                            style: UIAlertActionStyle.Cancel,
    //                                                                                            handler: nil)
    //
    //                self.showAlertWithData(applicationDelegate.getLocalizeStringForKey("ALERT_CONFIRM_REMOVE_FAVORITE"),
    //                        message: nil,
    //                        completionHandler: { (UIAlertAction) -> Void in
    //                            applicationDelegate.appSetting?.callServiceRemoveFavoriteForJobCode(self, jobCode: (jobData?.runningNumber)!, completion: { () -> Void in
    //                                gridCell.setUIAddFavoriteButton(isAddFavorite)
    //                                jobData?.isResumeFavorite = isAddFavorite
    //                            })
    //                        },
    //                        actionList: [cancelAction])
    //            }
    //        } else {
    //            // alert Not Login
    //            self.showAlertWithData("",
    //                                    message: applicationDelegate.getLocalizeStringForKey("MESSAGE_NOT_LOG_IN"),
    //                                    completionHandler: nil,
    //                                    actionList: nil)
    //            
    //        }
    //    }
}
