//
//  JTMSearchResultListTableViewCell.swift
//  JobThai
//
//  Created by weerapon on 2/17/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
//import AlamofireImage
import MHVideoPhotoGallery

class JTMSearchResultListCollectionViewCell: UICollectionViewCell {
    
    @IBOutlet weak var imageCompany : UIImageView?
    @IBOutlet weak var sequence : JTMLabel?
    @IBOutlet weak var date : JTMLabel?
    @IBOutlet weak var positionJob : JTMLabel?
    @IBOutlet weak var companyName : JTMLabel?
    @IBOutlet weak var province : JTMLabel?
    @IBOutlet weak var salary : JTMLabel?
    @IBOutlet weak var salaryImg: UIImageView!
    @IBOutlet weak var bottomBorderView: UIView!
    @IBOutlet weak var topBorderView: UIView!
    @IBOutlet weak var topBorderHeightConstraint: NSLayoutConstraint!
    @IBOutlet weak var bottomBorderHeightConstraint: NSLayoutConstraint!
    
    let SELECTED_BODER_WIDTH: CGFloat = 2.5
    let BORDER_WIDTH: CGFloat = JTM_CELL_BORDER_HEIGHT//2
    let BORDER_COLOR = JTM_CELL_SEPERATOR_COLOR//JTM_BROWSEJOB_HOME_BG_COLOR
    let SELECTED_BG_COLOR = JTM_HIGHLIGHT_COLOR
    
    var view : UIView?
    
    
    func setDataToCell(item : JobItem,sequence :Int) {
        self.sequence?.text = "\(sequence+1)"
        self.topBorderHeightConstraint.constant = (sequence == 0) ? BORDER_WIDTH : 0
        self.date?.text = item.dateText
        
        if item.companyLogo != nil {
            self.imageCompany?.hidden = false
            self.imageCompany?.sd_setImageWithURL(item.companyLogo!, placeholderImage: UIImage())
//            self.imageCompany?.af_setImageWithURL(item.companyLogo!)
        } else {
            self.imageCompany?.hidden = true
        }
        self.positionJob?.text = item.jobTitle
        self.companyName?.text = item.companyName
        if item.contryCode == "TH" {
            self.province?.text = item.provice
        } else {
            self.province?.text = item.national
        }
        
        self.salary?.text = item.salary
        self.salaryImg.hidden = (item.salary == "")
        self.salary?.hidden = (item.salary == "")
    }
    
    override func awakeFromNib() {
        self.setCellBorder()
        self.setSelectedBackgroundView()
    }
 
//    func setCellBorder() {
//        self.layer.borderWidth = BORDER_WIDTH
//        self.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
//    }
    
    //MARK:- Set Border
    func setCellBorder() {
        
        // Top border
        self.topBorderView.backgroundColor = BORDER_COLOR
        self.topBorderHeightConstraint.constant = BORDER_WIDTH

        // Bottom border
        self.bottomBorderView.backgroundColor = BORDER_COLOR
        self.bottomBorderHeightConstraint.constant = BORDER_WIDTH
    }
    
    
    func setSelectedBackgroundView() {
//        let backgroundView = UIView(frame: self.frame)
//        backgroundView.backgroundColor = UIColor.clearColor()
//        backgroundView.layer.borderWidth = SELECTED_BODER_WIDTH
//        backgroundView.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
//        
//        self.selectedBackgroundView = backgroundView
        
        let backgroundView = UIView(frame: self.frame)
        backgroundView.backgroundColor = SELECTED_BG_COLOR
//        backgroundView.layer.borderWidth = SELECTED_BODER_WIDTH
//        backgroundView.layer.borderColor = JTM_SELECTED_CELL_BORDER_COLOR.CGColor
        
        self.selectedBackgroundView = backgroundView
    }
}
