
//
//  JTMSearchResultMapFooterControlView.swift
//  JobThai
//
//  Created by pinyo on 3/2/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMSearchResultMapFooterControlView: UIView {
    @IBOutlet var currentLocationButton : UIButton!
    @IBOutlet var backPageButton : UIButton!
    @IBOutlet var nextPageButton : UIButton!
    @IBOutlet var currentPageLabel : UILabel!
    
    var currentPageIndex : Int!
    var countAllPage : Int!
    
    var delegate : JTMSearchResultMapFooterControlViewDelegate!
    var view: UIView!
    
    //Load Nib File
    override init(frame: CGRect) {
        super.init(frame: frame)
        setupUi()
    }
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
        setupUi()
    }
    
    func setupUi(){
        view = loadViewFromNib()
        view.frame = bounds
        view.autoresizingMask = [.FlexibleWidth , .FlexibleHeight]
        addSubview(view)
    }
    
    func loadViewFromNib() -> UIView {
        let bundle = NSBundle(forClass:self.dynamicType)
        let nib = UINib(nibName: "JTMSearchResultMapFooterControlView", bundle: bundle)
        let view = nib.instantiateWithOwner(self, options: nil).first as! UIView
        return view
    }

    
    @IBAction func showCurrentLocation(){
        delegate.footerControlCurrentLocationButtonClicked()
    }
    
    @IBAction func backPageButtonClicked(){
        delegate.footerControlBackPageButtonClicked()
    }
    
    @IBAction func nextPageButtonClick(){
        delegate.footerControlNextPageButtonClicked()
    }
    
    func setCurrentPageLabel(index : Int , numOfPage : Int){
        self.currentPageIndex = index
        self.countAllPage = numOfPage
        let pagePrefix : String = applicationDelegate.getLocalizeStringForKey("SEARCH_MAP_FOOTER_PAGE")
        self.currentPageLabel.text = "\(pagePrefix) \(index)/\(numOfPage)"
        if numOfPage == 1{
            self.backPageButton.hidden = true
            self.nextPageButton.hidden = true
        }
        else if index == 1{
            self.backPageButton.hidden = true
            self.nextPageButton.hidden = false
        }
        else if index == numOfPage{
            self.backPageButton.hidden = false
            self.nextPageButton.hidden = true
        }
        else{
            self.backPageButton.hidden = false
            self.nextPageButton.hidden = false
        }
    }
    
    func setButtonEnableStatus(enable: Bool) {
        self.backPageButton.userInteractionEnabled = enable
        self.nextPageButton.userInteractionEnabled = enable
    }
}

protocol JTMSearchResultMapFooterControlViewDelegate{
    func footerControlNextPageButtonClicked()
    func footerControlBackPageButtonClicked()
    func footerControlCurrentLocationButtonClicked()
}
