//
//  JTMSearchResultViewController.swift
//  JobThai
//
//  Created by weerapon on 1/21/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMSearchResultViewController: JTMBaseViewController, UIPageViewControllerDataSource, UIPageViewControllerDelegate, JTMMainSeachResultDelegate, UIScrollViewDelegate {
    
    
    
    // Search List and Grid
    var nextPage = 1
    var searchResultData : SearchResultModel?
    var searchResultSortFilterList = [SortFilterModel]()
    var sortFilterIndex = 0
    var mapSearchResultData: SearchResultMapModel?
    
    var isLoadFirstService : Bool = false
    var isFirstNotConnectInternet : Bool = false
    var allCountPage = 0
    var paramSearch: [String:AnyObject]? //= ""
    var isOpenFromSearchMap = false
    
    // PageView
    var pageViewController : UIPageViewController?
    var pageTitles : NSMutableArray = ["List", "Grid", "Map"]
    var currentIndex : NSInteger = NSNotFound
    
    var isWillTransition : Bool = false
    
    // Delegate to set status Button
    var delegateSeachResult : JTMSearchResultStatusDelegate?
    
    // Object List Gird Map
    var listViewController : JTMSearchResultListViewController!
    var gridViewController : JTMSearchResultGirdViewController!
    var mapViewController : JTMSearchResultMapViewController!
    static var mapView : RMMapView!
    var mapRadiusArea : Double = 0
    
    var seachResultMainSeachResult : JTMMainSearchResultViewController!
    
    let SEARCH_RESULT_NULL_DATA = -1
    
    // ADS SETTING
    var ADS_SHOW : Bool = true // default value
    var ADS_COUNT : Int = 1  // 1 ads default value
    var ADS_POSITION_GRID : Int = 5 // position between 5 and 6 default value
    var ADS_POSITION_LIST : Int = 5 // position between 5 and 6 default value
    let ADS_USERDEFAULT_KEY : String = "ADS_USERDEFAULT_KEY"
    
    override func viewDidLoad() {
        super.viewDidLoad()
        self.initialResultChildViewController()
        
        self.delegateSeachResult = self.seachResultMainSeachResult
        self.initailPageView()
        initSortFilterList()
        
        //ADS_SHOW = isAdsShow()
        ADS_SHOW = NSUserDefaults.standardUserDefaults().valueForKey(ADS_USERDEFAULT_KEY) as! Bool
        print("==== ADS IS \(ADS_SHOW) ====")
    }
    
    override func viewWillAppear(animated: Bool) {
        super.viewWillAppear(animated)
        
        if self.isWillTransition {
            self.isWillTransition = false
            let currentPageIndex : NSInteger = getCurrentIndex((self.pageViewController?.viewControllers?.first)!)
            onClickOpenPageView(currentPageIndex)
        }
    }
        
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    
    override func initNoInterNetView() {
        isPresentedInOtherController = true
        super.initNoInterNetView()
    }
    
    override func manageViewAfterInternetNotReachable() {
        super.manageViewAfterInternetNotReachable()
        enableSwipePageView(false)
    }
    
    override func manageViewAfterInternetReachable() {
        super.manageViewAfterInternetReachable()
        enableSwipePageView(true)
    }
    
    func updateAdsPosition () {
        ADS_POSITION_GRID = (searchResultData?.gridPositionAds)!
        ADS_POSITION_LIST = (searchResultData?.listPositionAds)!
    }
    
//    func isAdsShow () -> Bool {
//        if let data = applicationDelegate.appSetting?.userData {
//            if data.showAds! {
//                ADS_COUNT = 0
//            }
//            else {
//                ADS_COUNT = 0
//            }
//            return data.showAds!
//        }
//        else {
//            return true
//        }
//    }
    
    func initialResultChildViewController() {
        listViewController = self.storyboard?.instantiateViewControllerWithIdentifier("JTMSearchResultListViewController") as? JTMSearchResultListViewController
        gridViewController = self.storyboard?.instantiateViewControllerWithIdentifier("JTMSearchResultGirdViewController") as? JTMSearchResultGirdViewController
        mapViewController = self.storyboard?.instantiateViewControllerWithIdentifier("JTMSearchResultMapViewController") as? JTMSearchResultMapViewController
        mapViewController.radiusNearMeInMeter = self.mapRadiusArea
        TNMapView.mapLanguageInit = mapViewController.getCurrentApplicationLanguage()
        
        // set parent to list
        listViewController.searchResultController = self
        gridViewController.searchResultController = self
        mapViewController.searchResultController = self
        
        // set delegate to list send data to mainSearch
        listViewController.delegateMainSeachResult = self.seachResultMainSeachResult
        gridViewController.delegateMainSeachResult = self.seachResultMainSeachResult
        mapViewController.delegateMainSeachResult = self.seachResultMainSeachResult
    }
        
    func initailPageView() {
        // Initail Pageview
        pageViewController = UIPageViewController(transitionStyle: .Scroll, navigationOrientation: .Horizontal, options: nil)
        pageViewController?.dataSource = self
        pageViewController?.delegate = self
   
        // Set First View
        let startingViewIndex = isOpenFromSearchMap ? SearchResultPageIndex.MAP_VIEW.rawValue : SearchResultPageIndex.GRID_VIEW.rawValue
        let startingViewController: UIViewController = viewControllerAtIndex(startingViewIndex)!
        let viewControllers = [startingViewController]
        pageViewController?.setViewControllers(viewControllers , direction: .Forward, animated: false, completion: nil)
        pageViewController?.view.frame = CGRectMake(0, 0, view.frame.size.width, view.frame.size.height);
        
        // Add to Pageview
        self.addChildViewController(pageViewController!)
        self.view.addSubview(pageViewController!.view)
        pageViewController?.didMoveToParentViewController(self)
        
        enableSwipePageView(true)
    }
    
    //MARK:- Sort Filter
    func setSortFilter(index: Int) {
        sortFilterIndex = index
        clearResultData()
//        gridViewController.isSortFilterChange = true
//        listViewController.isSortFilterChange = true
        self.listViewController.onClickBackToTop()
        self.gridViewController.onClickBackToTop()
    }
    
    func clearResultData() {
        searchResultData = nil
        self.listViewController.setNumberOfItem()
        self.gridViewController.setNumberOfItem()
        self.listViewController.listResultCollectionView?.reloadData()
        self.gridViewController.searchResultGridCollectionView?.reloadData()
        
        isLoadFirstService = false
        nextPage = 1
        self.seachResultMainSeachResult.reloadPageOnSortFilterChange()
    }
    
    func enableSwipePageView(enable: Bool) {
        for view in (pageViewController?.view.subviews)! {
            if let scrollView = view as? UIScrollView {
                scrollView.scrollEnabled = enable
                scrollView.delegate = self
            }
        }
    }
    
    //MARK: Before Page
    func pageViewController(pageViewController: UIPageViewController, viewControllerBeforeViewController viewController: UIViewController) -> UIViewController? {
        // check index
        var index : NSInteger = getCurrentIndex(viewController)
        
        if (index == 0) || (index == NSNotFound) {
            return nil
        }

        index -= 1
        
        return viewControllerAtIndex(index)
    }
    
    //MARK: After Page
    func pageViewController(pageViewController: UIPageViewController, viewControllerAfterViewController viewController: UIViewController) -> UIViewController? {
        // check index
        var index : NSInteger = getCurrentIndex(viewController)
        
        if index == NSNotFound {
            return nil
        }
        
        index += 1
        
        if (index == self.pageTitles.count) {
            return nil
        }
        
        return viewControllerAtIndex(index)
    }
    
    // Select ViewController
    func viewControllerAtIndex(index: Int) -> UIViewController? {
        if self.pageTitles.count == 0 || index >= self.pageTitles.count {
            return nil
        }
        
        let pageIndex = SearchResultPageIndex(rawValue: index)
        switch pageIndex! {
            case .LIST_VIEW:
                return listViewController
            case .GRID_VIEW:
                return gridViewController
            case .MAP_VIEW:
                return mapViewController
        }
    }
    
    //MARK: getCurrentIndex
    func getCurrentIndex(viewController : UIViewController)-> NSInteger {
        // check index
        var index : NSInteger = NSNotFound
        
        if viewController.isKindOfClass(JTMSearchResultListViewController) {
            index = (viewController as! JTMSearchResultListViewController).pageIndex.rawValue
        } else if( viewController .isKindOfClass(JTMSearchResultGirdViewController)){
            index = (viewController as! JTMSearchResultGirdViewController).pageIndex.rawValue
        } else if( viewController .isKindOfClass(JTMSearchResultMapViewController)){
            index = (viewController as! JTMSearchResultMapViewController).pageIndex.rawValue
        }
        
        return index
    }
    
    //MARK: Delegate onClick
    func onClickOpenPageView(index: Int) {
        self.contentScroll = 0.0
        let currentPageIndex : NSInteger = getCurrentIndex((self.pageViewController?.viewControllers?.first)!)
        var direction: UIPageViewControllerNavigationDirection?
        
        if (index > currentPageIndex) {
            direction = .Forward
        } else {
            direction = .Reverse
        }
        
        if !isWillTransition {
            self.pageViewController?.setViewControllers([viewControllerAtIndex(index)!], direction: direction!, animated: false, completion: { (success) -> Void in
                if success{
                    self.delegateSeachResult?.setStatusButtonCurrentSeachResult(index)
                }
            })
        }
    }
    
    //MARK: Set parameter to search
    func parameterSearch(param: [String:AnyObject]) {
        self.paramSearch = param//"\(param)"
    }
    
    func getParameterForSortFilter() -> String {
        if (searchResultSortFilterList.count > 0) {
            let parameter = searchResultSortFilterList[sortFilterIndex].parameter
            return  parameter!//"&sorting=\(parameter!)"
        } else {
            return ""
        }
    }
    
    func getParamForSearch() -> [String:AnyObject] {//String {
        self.paramSearch?["sorting"] = self.getParameterForSortFilter()
        return self.paramSearch!//"\(self.paramSearch)\(self.getParameterForSortFilter())"
    }
    
    //MARK:-sort filter
    func initSortFilterList() {
        searchResultSortFilterList.removeAll()
        
        if let path = NSBundle.mainBundle().pathForResource("ListSearchResultSortFilter", ofType: "plist") {
            let listSetting = NSMutableArray(contentsOfFile: path)!
            for sortFilter in listSetting {
                searchResultSortFilterList.append(SortFilterModel(sortFilterDictionary: sortFilter as! NSMutableDictionary))
            }
        }
    }

    func pageViewController(pageViewController: UIPageViewController, didFinishAnimating finished: Bool, previousViewControllers: [UIViewController], transitionCompleted completed: Bool) {
//        delegateSeachResult?.setStatusButtonCurrentSeachResult(self.getCurrentIndex((self.pageViewController?.viewControllers?.first)!))
        self.isWillTransition = false
        
        let testCount = self.searchResultData?.countAllJob != nil ? self.searchResultData?.countAllJob : SEARCH_RESULT_NULL_DATA
        
        if (self.pageViewController?.viewControllers?.first! == self.mapViewController){
            seachResultMainSeachResult.setSeachMainPosition((self.pageViewController?.viewControllers?.first)!, position: 0)
            self.mapViewController.zoomToAllAnnotation()
        } else {
            seachResultMainSeachResult.setSeachMainPosition((self.pageViewController?.viewControllers?.first)!, position: testCount!)
//            seachResultMainSeachResult.setSeachMainPosition((self.pageViewController?.viewControllers?.first)!, position: (self.searchResultData?.countAllJob)!)
        }
        
    }
    
    //MARK:- Call Back When Application Did Active
    override func applicationDidEnterBackground() {
        if isWillTransition {
            isWillTransition = false
            self.onClickOpenPageView(getCurrentIndex((self.pageViewController?.viewControllers?.first)!))
        }
    }
    
    func pageViewController(pageViewController: UIPageViewController, willTransitionToViewControllers pendingViewControllers: [UIViewController]) {
        self.isWillTransition = true
    }
    
    func updatePageTitleList() {
        let isMapEnable = (searchResultData?.isHasResultMap)!
        let isContainMapControllerInPageView = pageTitles.contains({$0 as! String == "Map"})
        
        if !isMapEnable && isContainMapControllerInPageView {
            pageTitles.removeObject("Map")
        } else if isMapEnable && !isContainMapControllerInPageView {
            pageTitles.insertObject("Map", atIndex: SearchResultPageIndex.MAP_VIEW.rawValue)
        }
    }
    
    //MARK:- PageView Scroll
    var indexScroll : NSInteger = 0
    var contentScroll : CGFloat = 0.0
    
    func scrollViewDidScroll(scrollView: UIScrollView) {
        let frame = scrollView.frame
        let offset = scrollView.contentOffset
    
        let summary : CGFloat = CGFloat(indexScroll) * frame.width + offset.x
        let horizontalVelocity = scrollView.panGestureRecognizer.velocityInView(scrollView).x
        
        if horizontalVelocity < 0 {
            if contentScroll < summary {
                contentScroll = summary
            }
        } else if horizontalVelocity > 0 {
            if contentScroll > summary {
                contentScroll = summary
            }
        }
      
        self.setButtionCurrentContentSize(contentScroll, scrollView: scrollView)
    }
    
    func scrollViewWillBeginDragging(scrollView: UIScrollView) {
        indexScroll = self.getCurrentIndex((self.pageViewController?.viewControllers?.first)!)
        let summary : CGFloat = CGFloat(indexScroll) * scrollView.frame.width + scrollView.contentOffset.x
        contentScroll = summary
    }
    
    func scrollViewDidEndDecelerating(scrollView: UIScrollView) {
        self.indexScroll = self.getCurrentIndex((self.pageViewController?.viewControllers?.first)!)
        let summary : CGFloat = CGFloat(self.indexScroll) * scrollView.frame.width + scrollView.contentOffset.x
        self.setButtionCurrentContentSize(summary, scrollView: scrollView)
    }
    
    func setButtionCurrentContentSize(contentSizeWhileScroll : CGFloat, scrollView : UIScrollView) {
        if contentSizeWhileScroll < scrollView.frame.width + scrollView.frame.width * 0.5 {
            delegateSeachResult?.setStatusButtonCurrentSeachResult(gridViewController.pageIndex.rawValue)
        } else if contentSizeWhileScroll < 2 * scrollView.frame.width + scrollView.frame.width * 0.5 {
            delegateSeachResult?.setStatusButtonCurrentSeachResult(listViewController.pageIndex.rawValue)
        } else {
            delegateSeachResult?.setStatusButtonCurrentSeachResult(mapViewController.pageIndex.rawValue)
        }
    }
}

protocol JTMSearchResultStatusDelegate {
    func setStatusButtonCurrentSeachResult(currentIndex : NSInteger)
}
