//
//  JTMSearchSuggestViewController.swift
//  JobThai
//
//  Created by ForAlL on 2/19/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMSearchSuggestViewController: JTMBaseViewController, UITableViewDataSource, UITableViewDelegate {

    @IBOutlet weak var tableView: UITableView!
    
    var listSuggestion = [String]()
    var listFilterSuggestion = [String]()
    
    var delegate = JTMSearchSuggestionControllerDelegate?()
    
    override func viewDidLoad() {
        isPresentedInOtherController = true
        super.viewDidLoad()
        tableView.tableFooterView = UIView(frame: CGRectZero)
        tableView.accessibilityIdentifier = "searchResultSuggestion"
    }
    
    override func viewWillAppear(animated: Bool) {
        listSuggestion = (applicationDelegate.appSetting?.getSearchSuggestionListFromUserDefault())!
    }

    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
    }
    
    //MARK:- Update Search Keyword
    func filterSuggest(keyword: String) {
        listFilterSuggestion = listSuggestion.filter({$0.rangeOfString(keyword, options: .CaseInsensitiveSearch, range: nil, locale: nil) != nil})//  containsString(keyword)})
        tableView.reloadData()
    }
    
    //MARK:- TableView
    func numberOfSectionsInTableView(tableView: UITableView) -> Int {
        return 1
    }
    
    func tableView(tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        return listFilterSuggestion.count
    }
    
    func tableView(tableView: UITableView, cellForRowAtIndexPath indexPath: NSIndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCellWithIdentifier("cell")
        if (listFilterSuggestion.count > indexPath.row) {
            cell?.textLabel?.text = listFilterSuggestion[indexPath.row]
        }
        
        return cell!
    }
    
    func tableView(tableView: UITableView, didSelectRowAtIndexPath indexPath: NSIndexPath) {
        if (delegate != nil) {
            delegate!.didSelectKeyword("\"\(listFilterSuggestion[indexPath.row])\"")
        }
    }
}

protocol JTMSearchSuggestionControllerDelegate {
    func didSelectKeyword(keyword:String)
}
