//
//  JTMShareSocial.swift
//  ApplyNow
//
//  Created by HARIKAN on 4/5/16.
//  Copyright © 2016 HARIKAN. All rights reserved.
//

import UIKit
class JTMShareSocial {
    
    func shareJob(controller: UIViewController, jobItem: PositionModel, companyName: String) {
        jobItem.jobLink! = addHttpToUrl(jobItem.jobLink!)
        
        if NSURL(string: jobItem.jobLink!) != nil {
            
            let placeholderItem = [
                "jobItem"   :   jobItem,
                "companyName"   :   companyName
            ]
            
            let provider = JTMActivityProvider(placeholderItem: placeholderItem)
            
            let activityController = UIActivityViewController(activityItems: [provider], applicationActivities: nil)
            activityController.excludedActivityTypes = [UIActivityTypeAssignToContact]
            activityController.setEmailSubjectForJob(jobItem.jobTitle!)
            
            activityController.completionWithItemsHandler = { (activity, success, items, error) in
                if success {
                    self.setTrackGoogleAnalytic(activity!)
                }
            }
            
            controller.presentViewController(activityController, animated: true, completion: nil)
        }
    }
    
    func addHttpToUrl(urlString: String) -> String {
        var url = urlString
        let isHasHttp = (urlString.rangeOfString("http://") != nil)
        let isHasHttps = (urlString.rangeOfString("https://") != nil)
        
        if !isHasHttp && !isHasHttps {
            url = "http://" + urlString
        }
        
        return url
    }
    
    func setTrackGoogleAnalytic(activity : String) {
        
        let shareActivity = activity.stringByReplacingOccurrencesOfString("com.apple.UIKit.activity.", withString: "")
        
        applicationDelegate.trackGoogleAnalyticEvent(CAT_JOB_DETAIL, action: ACTION_CLICK, label: getLabelShare(shareActivity))
    }
}

extension UIActivityViewController {
    func setEmailSubjectForJob(jobTitle:String) {
        let subjectPrefix = applicationDelegate.getLocalizeStringForKey("SHARE_JOB_EMAIL_SUBJECT_PREFIX")
        let emailSubject = subjectPrefix + jobTitle
        
        self.setValue(emailSubject, forKey: "subject")
    }
}
