//
//  JTMTextView.swift
//  JobThai
//
//  Created by pizhayut on 7/26/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMTextView : UITextView {
    
    required init?(coder aDecoder: NSCoder) {
        super.init(coder: aDecoder)
    }
    
    @IBInspectable var iPhone35FontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_3_5_INCH  {
                overrideFontSize(iPhone35FontSize)
            }
        }
    }
    
    @IBInspectable var iPhone4FontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_4_0_INCH  {
                overrideFontSize(iPhone4FontSize)
            }
        }
    }
    
    @IBInspectable var iPhone47FontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_4_7_INCH  {
                overrideFontSize(iPhone47FontSize)
            }
        }
    }
    
    @IBInspectable var iPhone55FontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_5_5_INCH  {
                overrideFontSize(iPhone55FontSize)
            }
        }
    }
    
    @IBInspectable var DefaultFontSize:CGFloat = 0 {
        didSet {
            if screenType == DisplaySizeType.SCREEN_UNKNOWN {
                overrideFontSize(DefaultFontSize)
            }
        }
    }
    
    @IBInspectable var canSelectable: Bool = false {
        didSet {
            self.selectable = canSelectable
        }
    }
    
    
    
    func overrideFontSize(fontSize:CGFloat){
//        self.font = UIFont.systemFontOfSize(fontSize)
        if let calculatedFont = UIFont(name: "HelveticaNeue", size: fontSize) {
            self.font = calculatedFont
        }
        self.selectable = canSelectable
    }

}
