//
//  JTMTransportationRadiusTableViewCell.swift
//  JobThai
//
//  Created by weerapon on 3/10/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class JTMTransportationRadiusTableViewCell : UITableViewCell {
    
    @IBOutlet weak var titleTransportArea: JTMLabel?
    @IBOutlet weak var prefixArea: JTMLabel?
    @IBOutlet weak var slider:UISlider?
    
    let CONSTANT_ONE = 1
    let CONSTANT_TWO = 2
    let CONSTANT_THREE = 3
    
    var startIndex = 2
    var arrayRadius = [0, 300, 500, 1000]
    var delegate : JTMAreaTransportationDelegate?
    
    override func awakeFromNib() {
        super.awakeFromNib()

        // Initialization code
        self.titleTransportArea!.text = applicationDelegate.getLocalizeStringForKey("TITLE_AREA_TRANSPORTATION_FRONT")
        setPrefixAreaText(arrayRadius[startIndex])
        self.addUITabGesture()
        self.setEdgeToLeft()
    }
    
    // Mark :: Add UITapGesture
    private func addUITabGesture() {
        let tap : UITapGestureRecognizer = UITapGestureRecognizer(target: self, action: #selector(sliderTappedAction(_:)))
        tap.delegate = self
        slider?.addGestureRecognizer(tap)
        slider?.userInteractionEnabled = true
    }
    
    // Mark :: Set Value
    private func setValeSider(index : Int) {
        slider?.setValue(Float(index), animated: false)
        let number = arrayRadius[index]
        
        if (startIndex != index) {
            setPrefixAreaText(number)
            delegate?.onValueAreaTransportChanged(Int(number))
            startIndex = index
        }
    }
    
    func setPrefixAreaText(value:Int) {
        self.prefixArea?.text =  applicationDelegate.numFormatter.stringFromNumber(value)! + " " + applicationDelegate.getLocalizeStringForKey("TITLE_AREA_TRANSPORTATION_BACK")
    }
    
    func setSliderValueTo(value:Int) {
        let index = arrayRadius.indexOf(value)
        setValeSider(index!)
    }
    
    // Mark :: Function Selector UITapGestureRecognizer
    func sliderTappedAction(sender: UITapGestureRecognizer) {
        let point = sender.locationInView(slider)
        var index = (Int)(Float(((point.x / CGRectGetWidth(slider!.bounds)) * 100)/33.3333333333333) + 0.5)
        if index == 0 {
            index = 1
        }
        self.setValeSider(index)
    }
    
    @IBAction func sliderValueChanged(sender: UISlider) {
        // if over 0.5 round up and less than 0.5 flick down
        let index = (Int)(slider!.value + 0.5)
        self.setValeSider(index)
    }
    
    // Mark :: Click Button Set Value
    @IBAction func onClickButtonOne() {
        self.setValeSider(CONSTANT_ONE)
    }
    
    @IBAction func onClickButtonTwo() {
        self.setValeSider(CONSTANT_TWO)
    }
    
    @IBAction func onClickButtonThree() {
        self.setValeSider(CONSTANT_THREE)
    }
}

protocol JTMAreaTransportationDelegate {
    func onValueAreaTransportChanged(value : Int)
}