//
//  MaintenanceModel.swift
//  JobThai
//
//  Created by pinyo on 6/24/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit

class MaintenanceModel {
    var alertTitle         : String?
    var alertMessage       : String?
    var urlImage           : String?
    var urlAppStore        : String?
    var description        : String?
    var type               : MaintenanceType?
    
    init(jsonObject : NSMutableDictionary) {
        self.alertTitle     = jsonObject.objectForKey("alertTitle")     as? String
        self.alertMessage   = jsonObject.objectForKey("alertMessage")   as? String
        self.urlImage       = jsonObject.objectForKey("urlImage")       as? String
        self.urlAppStore    = jsonObject.objectForKey("urlAppstore")    as? String
        self.description    = jsonObject.objectForKey("description")    as? String
        
        if let mainTeneType = jsonObject.objectForKey("type") as? Int {
            self.type = MaintenanceType(rawValue: mainTeneType)
        } else {
            self.type = MaintenanceType.MODE_CONNECTION_FAIL
        }
    }
    
    init(title : String ,message : String , urlImage : String , urlAppStore : String , description : String , type : MaintenanceType) {
        self.alertTitle         = title
        self.alertMessage       = message
        self.urlImage           = urlImage
        self.urlAppStore        = urlAppStore
        self.description        = description
        self.type               = type
    }
    
    init(type : MaintenanceType) {
        self.type = type
    }
    
}