//
//  SearchResultMapModel.swift
//  JobThai
//
//  Created by pinyo on 3/2/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import Foundation
import UIKit

class SearchResultMapModel {
    var countAllJob : Int?
    var countJob : Int?
    var countPage : Int?
    var canViewMap : Bool?
    var perPage : Int?
    var countPin : Int?
    var countAllPin : Int?
    var jobAllPage = NSMutableDictionary()
    
    init(result : NSMutableDictionary , currentPage : Int) {
        let jobListResult = result.objectForKey("jobList") as? NSArray
        var tmpJobList = [JobItem]()
        for itemJob in jobListResult! {
            let item = JobItem(item: itemJob as! NSMutableDictionary)
            tmpJobList.append(item)
        }
        self.jobAllPage.setObject(self.groupJobListByPinID(tmpJobList), forKey: currentPage)
        
        self.countAllJob = result.objectForKey("countAllJobs") as? Int
        self.countJob = result.objectForKey("countJobs") as? Int
        self.countPage = result.objectForKey("countPage") as? Int
        self.canViewMap = result.objectForKey("canViewMap") as? Bool
        self.perPage = result.objectForKey("perPage") as? Int
        self.countAllPin = result.objectForKey("countAllPins") as? Int
        self.countPin = result.objectForKey("countPins") as? Int
    }
    
    func insertNewJobList(result : NSMutableDictionary , currentPage : Int){
        if let dataJobList = self.jobAllPage.objectForKey(currentPage) as? NSMutableArray{
            print("Found Job Page [\(currentPage)] : \(dataJobList.count) Jobs")
        }else{
            let jobListResult = result.objectForKey("jobList") as? NSArray
            var tmpJobList = [JobItem]()
            for itemJob in jobListResult! {
                let item = JobItem(item: itemJob as! NSMutableDictionary)
                tmpJobList.append(item)
            }
            self.jobAllPage.setObject(self.groupJobListByPinID(tmpJobList), forKey: currentPage)
        }
    }
    
    func groupJobListByPinID( allJobList : [JobItem]) -> NSMutableDictionary{
        let jobListGroupPin = NSMutableDictionary()
        
        for jobItem in allJobList {
            if let jobListAtPinId = jobListGroupPin.objectForKey(jobItem.pinId!) as? NSMutableArray{
                jobListAtPinId.addObject(jobItem)
            }else{
                jobListGroupPin.setObject(NSMutableArray(object: jobItem), forKey: jobItem.pinId!)
            }
        }
        return jobListGroupPin
    }
}
