//
//  UserCredentialModel.swift
//  JobThai
//
//  Created by kanya on 2/3/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import UIKit
import KeychainSwift

class UserCredentialModel: NSObject {
    var username:String?
//    var password:String?
    var token:String?
    var sessionId : String?
    var keychainItem:KeychainSwift

    override init() {
        keychainItem = KeychainSwift()
        
        self.username = ""
        self.token = ""
        self.sessionId = ""
    }
    
    
    // MARK-: Get While Open App and Auto Login
    func getStoredCredential() -> UserCredentialModel {
        self.getSavedUser()
        self.getSavedToken()
        self.getSessionId()
        return self
    }
    
    func rememberUserCredential() {
        print("save credential")
        
        let isRememberMe = applicationDelegate.appSetting?.getIsRememberMe()
        
        if (isRememberMe == true) {
            NSUserDefaults.standardUserDefaults().setValue(username, forKey: JTM_SAVED_USERNAME_KEY)
            NSUserDefaults.standardUserDefaults().synchronize()
            
            keychainItem.set(token!, forKey: JTM_SAVED_TOKEN_KEY)
            // Session
            
            keychainItem.set(sessionId!, forKey: JTM_SAVED_SESSION_KEY)
            print("s : \(sessionId)")
            
        } else {
            self.removeSavedUser()
            self.removeUserCredential()
        }
    }
    
    func removeUserCredential() {
        print("remove credential")
        
//        self.password = ""
        self.token = ""
        
//        keychainItem.set("", forKey: JTM_SAVED_PASSWORD_KEY)
        keychainItem.set("", forKey: JTM_SAVED_TOKEN_KEY)
        
        // Remove keychain Session ID
        keychainItem.set("", forKey: JTM_SAVED_SESSION_KEY)
        
        self.getStoredCredential()
    }
    
    func removeSavedUser() {
        print("remove saves user")
        
        self.username = ""
        NSUserDefaults.standardUserDefaults().setValue("", forKey: JTM_SAVED_USERNAME_KEY)
        NSUserDefaults.standardUserDefaults().synchronize()
    }
    
    func getSavedUser() {
        if let savedUsername = NSUserDefaults.standardUserDefaults().valueForKey(JTM_SAVED_USERNAME_KEY) {
            self.username = savedUsername as? String
        } else {
            self.username = ""
        }
    }
    
    
    func getSavedToken() {
        if let savedToken = keychainItem.get(JTM_SAVED_TOKEN_KEY) {
            self.token = savedToken
        } else {
            self.token = ""
        }
    }
    
    func getSessionId() {
        if let savedSessionId = keychainItem.get(JTM_SAVED_SESSION_KEY) {
            self.sessionId = savedSessionId
        } else {
            self.sessionId = ""
        }
    }
    
}
