//
//  JTMApplyJobTests.swift
//  JobThai
//
//  Created by weerapon on 4/29/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import XCTest

class JTMApplyJobTests: XCTestCase {
    
    let app = XCUIApplication()
    
    
    // Mark-: Apply Success
    /* 
        User :
        Password : 
        Applied index : 
    */
    
    func testApplyNotLogin() {
        app.launch()
        sleep(4)
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic search"].tap()
        
        // Select Table Search Filter
        let searchFilterQuery = app.tables
        searchFilterQuery.cells.elementBoundByIndex(0).tap()
        
        
        let keywordSearch = app.textFields["searchKeyword"]
        keywordSearch.tap()
        
        let searchByKeyword = app.otherElements["searchFilterSeachBar"]
        searchByKeyword.typeText("THiNKNET")
        app.tables["searchResultSuggestion"].cells.elementBoundByIndex(0).tap()
        
        
        app.buttons["searchFillterQuickSearchButton"].tap()
        
        let searchResultCollectionView = app.collectionViews
        searchResultCollectionView.cells.elementBoundByIndex(0).tap()
        
        sleep(1)
        app.otherElements["applyjobView"].tap()

        let alertView = app.alerts["alert"]
        let alertButton = alertView.collectionViews.buttons
        let okButton = alertButton.elementBoundByIndex(1)
        okButton.tap()
        
        let username = app.textFields["usernameTextField"]
        username.tap()
        username.clearText()
        username.typeText("benjabhon@gmail.com")
        
        let password = app.secureTextFields["passwordTextField"]
        password.tap()
        password.typeText("testtest")
        
        app.buttons["loginButton"].tap()
        
        let textviewQuery = app.textViews["descriptionTextView"]
        textviewQuery.tap()
        textviewQuery.typeText("Test Apply Mobile")
        
        app.childrenMatchingType(.Window).elementBoundByIndex(0).childrenMatchingType(.Other).element.childrenMatchingType(.Other).element.tap()
        
        app.otherElements["applyViewClick"].tap()
        sleep(2)
        
        let alertViewApply = app.alerts["alert"]
        let alertButtonApply = alertViewApply.collectionViews.buttons
        let okButtonApply = alertButtonApply.elementBoundByIndex(0)
        okButtonApply.tap()
        
        sleep(3)
    }
    
    // Mark-: Not Success
    /*
        User : vaiohkae@gmail.com
        Password : testuser
        Applied index : 0
    */
    func testApplyLoginApplied() {
        app.launch()
        sleep(4)
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic search"].tap()
        
        // Select Table Search Filter
        let searchFilterQuery = app.tables
        searchFilterQuery.cells.elementBoundByIndex(0).tap()
        
        
        let keywordSearch = app.textFields["searchKeyword"]
        keywordSearch.tap()
        
        let searchByKeyword = app.otherElements["searchFilterSeachBar"]
        searchByKeyword.typeText("THiNKNET")
        app.tables["searchResultSuggestion"].cells.elementBoundByIndex(0).tap()
        
        
        app.buttons["searchFillterQuickSearchButton"].tap()
        
        let searchResultCollectionView = app.collectionViews
        searchResultCollectionView.cells.elementBoundByIndex(0).tap()
        
        sleep(1)
        app.otherElements["applyjobView"].tap()
        sleep(2)
        
        let alertView = app.alerts["alert"]
        let alertButton = alertView.collectionViews.buttons
        let okButton = alertButton.elementBoundByIndex(0)
        okButton.tap()
        
        sleep(3)
    }
    
    // Mark-: Apply Success
    func testApplyNotLoginHaveUserName() {
        app.launch()
        sleep(4)
        
        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic slide menu"].tap()
        
        let mainMenu = app.tables[ID_MAIN_MENU_TABLE_VIEWS]
        mainMenu.cells.elementBoundByIndex(7).tap()
        
        let alertLogOut = app.alerts[ID_ALERT_LOGOUT]
        let alertButtonLogOut = alertLogOut.collectionViews.buttons
        //let cancelButton = alertButtonLogOut.elementBoundByIndex(0)
        let LogOutButton = alertButtonLogOut.elementBoundByIndex(1)
        LogOutButton.tap()

        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic search"].tap()
        
        // Select Table Search Filter
        let searchFilterQuery = app.tables
        searchFilterQuery.cells.elementBoundByIndex(0).tap()
        
        
        let keywordSearch = app.textFields["searchKeyword"]
        keywordSearch.tap()
        
        let searchByKeyword = app.otherElements["searchFilterSeachBar"]
        searchByKeyword.typeText("THiNKNET")
        app.tables["searchResultSuggestion"].cells.elementBoundByIndex(0).tap()
        app.buttons["searchFillterQuickSearchButton"].tap()
    

        let searchResultCollectionView = app.collectionViews["ID_SEARCH_RESULT_LIST_COLLECTION_VIEWS"]
        searchResultCollectionView.cells.elementBoundByIndex(1).tap()
        
        app.otherElements["applyjobView"].tap()
        
        let alertView = app.alerts["alert"]
        let alertButton = alertView.collectionViews.buttons
        let okButton = alertButton.elementBoundByIndex(1)
        okButton.tap()
        
        let password = app.secureTextFields["passwordTextField"]
        password.tap()
        password.typeText("testuser")
        
        app.buttons["loginButton"].tap()
        
        let textviewQuery = app.textViews["descriptionTextView"]
        textviewQuery.tap()
        textviewQuery.typeText("Test Apply Mobile")
        
        app.childrenMatchingType(.Window).elementBoundByIndex(0).childrenMatchingType(.Other).element.childrenMatchingType(.Other).element.tap()
        
        app.otherElements["applyViewClick"].tap()
        sleep(2)
        
        let alertViewApply = app.alerts["alert"]
        let alertButtonApply = alertViewApply.collectionViews.buttons
        let okButtonApply = alertButtonApply.elementBoundByIndex(0)
        okButtonApply.tap()
        
        sleep(3)
    }
    
//    // Mark-: Login and Apply Success
//    func testApplyLoginSuccess() {
//        app.launch()
//        sleep(4)
//        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic search"].tap()
//        
//        // Select Table Search Filter
//        let searchFilterQuery = app.tables
//        searchFilterQuery.cells.elementBoundByIndex(0).tap()
//        
//        
//        let keywordSearch = app.textFields["searchKeyword"]
//        keywordSearch.tap()
//        
//        let searchByKeyword = app.otherElements["searchFilterSeachBar"]
//        searchByKeyword.typeText("THiNKNET")
//        app.tables["searchResultSuggestion"].cells.elementBoundByIndex(0).tap()
//        
//        
//        app.buttons["searchFillterQuickSearchButton"].tap()
//        
//        let searchResultCollectionView = app.collectionViews
//        searchResultCollectionView.cells.elementBoundByIndex(7).tap()
//        
//        sleep(1)
//        app.otherElements["applyjobView"].tap()
//        
//        print(app.textViews.debugDescription)
//        
//        let textviewQuery = app.textViews["descriptionTextView"]
//        textviewQuery.tap()
//        textviewQuery.typeText("Test Apply Mobile")
//        
//        app.childrenMatchingType(.Window).elementBoundByIndex(0).childrenMatchingType(.Other).element.childrenMatchingType(.Other).element.tap()
//        
//        app.otherElements["applyViewClick"].tap()
//        sleep(2)
//        
//        let alertView = app.alerts["alert"]
//        let alertButton = alertView.collectionViews.buttons
//        let okButton = alertButton.elementBoundByIndex(0)
//        okButton.tap()
//
//        sleep(3)
//    }
//
//    
//    // Mark-: Applied
//    /*
//        User : vaiohkae@gmail.com
//        Password : testuser
//        Applied index : 0
//    */
//    func testAppliedNotLogin() {
//        app.launch()
//        sleep(4)
//        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic search"].tap()
//        
//        // Select Table Search Filter
//        let searchFilterQuery = app.tables
//        searchFilterQuery.cells.elementBoundByIndex(0).tap()
//        
//        let keywordSearch = app.textFields["searchKeyword"]
//        keywordSearch.tap()
//        
//        let searchByKeyword = app.otherElements["searchFilterSeachBar"]
//        searchByKeyword.typeText("THiNKNET")
//        app.tables["searchResultSuggestion"].cells.elementBoundByIndex(0).tap()
//        
//        
//        app.buttons["searchFillterQuickSearchButton"].tap()
//        
//        let searchResultCollectionView = app.collectionViews
//        searchResultCollectionView.cells.elementBoundByIndex(0).tap()
//        
//        sleep(1)
//        app.otherElements["applyjobView"].tap()
//        
//        let alertView = app.alerts["alert"]
//        let alertButton = alertView.collectionViews.buttons
//        let okButton = alertButton.elementBoundByIndex(1)
//        okButton.tap()
//        
//        let username = app.textFields["usernameTextField"]
//        username.tap()
//        username.typeText("vaiohkae@gmail.com")
//        
//        let password = app.secureTextFields["passwordTextField"]
//        password.tap()
//        password.typeText("testuser")
//        
//        app.buttons["loginButton"].tap()
//        
//        let alertViewApply = app.alerts["alert"]
//        let alertButtonApply = alertViewApply.collectionViews.buttons
//        let okButtonApply = alertButtonApply.elementBoundByIndex(0)
//        okButtonApply.tap()
//        
//        sleep(3)
//    }
//    
//    // Mark-: Apply Success
//    /*
//    User : vaiohkae@gmail.com
//    Password : testuser
//    Applied index : 0
//    */
//    func testAppliedNotLoginHaveUserName() {
//        app.launch()
//        sleep(4)
//        app.navigationBars[ID_MAIN_NAVIGATION_BAR].buttons["ic search"].tap()
//        
//        // Select Table Search Filter
//        let searchFilterQuery = app.tables
//        searchFilterQuery.cells.elementBoundByIndex(0).tap()
//        
//        
//        let keywordSearch = app.textFields["searchKeyword"]
//        keywordSearch.tap()
//        
//        let searchByKeyword = app.otherElements["searchFilterSeachBar"]
//        searchByKeyword.typeText("THiNKNET")
//        app.tables["searchResultSuggestion"].cells.elementBoundByIndex(0).tap()
//        
//        
//        app.buttons["searchFillterQuickSearchButton"].tap()
//        
//        let searchResultCollectionView = app.collectionViews
//        searchResultCollectionView.cells.elementBoundByIndex(0).tap()
//        
//        sleep(1)
//        app.otherElements["applyjobView"].tap()
//        
//        let alertView = app.alerts["alert"]
//        let alertButton = alertView.collectionViews.buttons
//        let okButton = alertButton.elementBoundByIndex(1)
//        okButton.tap()
//        
//        let password = app.secureTextFields["passwordTextField"]
//        password.tap()
//        password.typeText("vaiohkae")
//        
//        app.buttons["loginButton"].tap()
//        
//        let alertViewApply = app.alerts["alert"]
//        let alertButtonApply = alertViewApply.collectionViews.buttons
//        let okButtonApply = alertButtonApply.elementBoundByIndex(0)
//        okButtonApply.tap()
//        
//        sleep(3)
//    }

    
}

extension XCTestCase {
    
    func tapElementAndWaitForKeyboardToAppear(element: XCUIElement) {
        let keyboard = XCUIApplication().keyboards.element
        while (true) {
            element.tap()
            if keyboard.exists {
                break;
            }
            NSRunLoop.currentRunLoop().runUntilDate(NSDate(timeIntervalSinceNow: 0.5))
        }
    }
    
    
    func waitForElementToAppear(element: XCUIElement, timeout: NSTimeInterval = 5,  file: String = __FILE__, line: UInt = __LINE__) {
        let existsPredicate = NSPredicate(format: "exists == true")
        
        expectationForPredicate(existsPredicate,
            evaluatedWithObject: element, handler: nil)
        
        waitForExpectationsWithTimeout(timeout) { (error) -> Void in
            if (error != nil) {
                let message = "Failed to find \(element) after \(timeout) seconds."
                self.recordFailureWithDescription(message, inFile: file, atLine: line, expected: true)
            }
        }
    }
}

extension XCUIElement {
    /**
     Removes any current text in the field before typing in the new value
     - Parameter text: the text to enter into the field
     */
    func clearText() -> Void {
        guard let stringValue = self.value as? String else {
            XCTFail("Tried to clear and enter text into a non string value")
            return
        }
        
//        self.tap()
        
        var deleteString: String = ""
        for _ in stringValue.characters {
            deleteString += "\u{8}"
        }
        self.typeText(deleteString)
    }
}