//
//  JTMPreloadViewControllerTest.swift
//  JobThai
//
//  Created by pinyo on 6/8/16.
//  Copyright © 2016 THiNKNET. All rights reserved.
//

import XCTest

class JTMPreloadViewControllerTest: XCTestCase {
    
    let SLEEP_FOR_UI            : UInt32 = 3
    let SLEEP_FOR_CLOSE_APP     : UInt32 = 5
    
    let app                 = XCUIApplication()
    let navBarBackButton    = XCUIApplication().buttons[ID_NAV_BAR_BACK_BUTTON]
    let homeView            = XCUIApplication().otherElements[ID_HOME_VIEW]

    let jobDetailView       = XCUIApplication().otherElements[ID_JOB_DETAIL_VIEW]
    let webView             = XCUIApplication().otherElements[ID_WEBVIEW_VIEW]
    
    let preloadView         = XCUIApplication().otherElements[ID_PRELOAD_VIEW]
    let preloadEnterButton  = XCUIApplication().buttons[ID_PRELOAD_ENTER_APP_BUTTON]
    let preloadImageView    = XCUIApplication().images[ID_PRELOAD_IMAGEVIEW]
    
    override func setUp() {
        super.setUp()
        sleep(SLEEP_FOR_UI)
        app.launch()
        sleep(SLEEP_FOR_UI)
    }
    
    override func tearDown() {
        super.tearDown()
        sleep(SLEEP_FOR_CLOSE_APP)
    }

    //MARK: Test Case
    //Case : Click Enter JobThai Button -> it's go to home view
    func testClickEnterJobThaiApp(){
        if(preloadEnterButton.exists){
            preloadEnterButton.tap()
            XCTAssert(homeView.exists)
        }else{
            XCTFail("Preload not show.")
        }
    }
    
    //Case : Click on preload image -> JobDetail or WebView
    func testClickOnPreloadImageView(){
        if(preloadImageView.exists){
            preloadImageView.tap()
            XCTAssert(actionPreloadIsWork())
        }else{
            XCTFail("Preload not show.Image not show.")
        }
    }
    
    //Case : Click on preload -> JobDetail or WebView -> Click Back[NavBar] -> it's go to home view
    func testBackToHomeViewAfterActionPreload(){
        if(preloadImageView.exists){
            preloadImageView.tap()
            if(actionPreloadIsWork()){
                navBarBackButton.tap()
            }
            XCTAssert(homeView.exists)
        }else{
            XCTFail("Preload not show.Image not show.")
        }
    }
    
    //MARK: Function for use 
    //Check Preload Action should be show JobDetail or WebView
    func actionPreloadIsWork() -> Bool {
        if(jobDetailView.exists || webView.exists){
            return true
        }
        return false
    }
}
